/*
 * -- main.h -- 
 * 
 * Header von main.cpp, stellt globale Variablen und Funktionsdeklarationen zur Verfügung
 * 
 * File:   main.h
 * Copyright 2013 Christoph Bultmann
 * 
 * This file is part of makergaulxx.
 *
 * makergaulxx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * makergaulxx is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with makergaulxx.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MAIN_H
#define	MAIN_H

//Eigene Downhill-Simplex-Klasse
#include "cl_points.h"
//Klasse, in der das Help-Menü und die Gnu-Lizens angezeigt werden
#include "cl_info.h"

using namespace std;

/* Deklaration der Downhill-Simplex-Funktion*/
int downhill_simplex_run();   

/* globale Variablen (werden nur innerhalb von main.cppbenutzt)*/
cl_points downhill_simplex;                                                                                             //Das benutzte Downhill-Simplex-Punktobjekt
/* Parameter, die nur Integer zulassen*/
string g_mode = "";                                                                                                     //Steuervariable zum Speichern von Konsolenbefehlen wie z.B. -v, -help oder -run
int g_head_pars = 0;                                                                                                    //Anzahl Ergebnissparameter, die ein Modell zurückgeben wird
int g_head_fix = 0;                                                                                                     //Anzahl Fixer, zusätzlicher Parameter, die zwar die Downhill-Simplex-Analyse beeinflussen, aber nicht in diese übernommen werden
int g_head_values = 0;                                                                                                  //Anzahl der in die Analyse eingeschlossenen Messwerte
int g_head_loops = 0;                                                                                                   //Anzahl Versuche
int g_head_rounds = 0;                                                                                                  //Anzahl Iterationsschritte
int g_head_wdh = 0;                                                                                                     //Wiederholungsbrecher (wird momentan nicht verwendet!))
int g_head_analysis = 1;                                                                                                //Gewähltes Analysemodell. 1 = MAKERGAUL, 2 = MAK2
/*Parameter, die Float-Werte enthalten können, werden direkt in GMP-MPF-Klassen gespeichert*/
mpf_class g_head_ref = 0;                                                                                               //Reflexionsfaktor der Downhill-Simplex-Analyse
mpf_class g_head_exp = 0;                                                                                               //Expansionsfaktor der Downhill-Simplex-Analyse
mpf_class g_head_con = 0;                                                                                               //Kontraktionsfaktor der Downhill-Simplex-Analyse
mpf_class g_head_step1 = 0;                                                                                             //Grenzwert für Fitness bei erstem Kontrollschritt
mpf_class g_head_step2 = 0;                                                                                             //Grenzwert für Fitness bei zweitem Kontrollschritt
mpf_class g_head_step3 = 0;                                                                                             //Grenzwert für Fitness bei drittem Kontrollschritt
mpf_class g_head_prec = 0;                                                                                              //Zielfitness

#endif	/* MAIN_H */

