<?php 
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

/*Session direkt starten
(An dieser Stelle ist z.B. auch die Integration in ein passwortgeschtztes Accountsystem mit MySQL-Benutzerdatenbank zu realisieren)*/
session_start();
/*----Progamminformation----*/
const PROGRAMM = "MAKERGAUL"; //Programmname (Bleibt fr alle Versionen fix)
const MAJOR_RELEASE = 1;      //Hauptversion
const MINOR_RELEASE = 0;      //Entwicklungsversion
const PATCH_LEVEL = 0;        //Patch zur Hauptversion
const INDEXFILE = __FILE__;   //Datei, in der sich das Script befindet
//Datei zur Bestimmung der absoluten Pfadangabe des Binary-Verzeichnisses 
//(Wird zum Aufrufen externer Anwendungen zwingend bentigt)
include_once("modules/analysis/binarys/exec_getpath.php"); 
//Absoluter Pfad des Binary-Verzeichnisses, endet mit "/" (UNIX) oder "\" (Windows)
//Wird aus Sicherheitsgrnden bei jedem Aufrufen aktualisiert!
$EXEC_PATH = exec_getpath();   


//Aus Sicherheitsgrnden bei jedem Seitenaufruf vor Include-Vorgang Modulpfade zurcksetzen und aktualisieren
    /*Einbinden aller Dateien, die sich in den Erweiterungsverzeichnissen befinden*/

    $Modules_Main = scandir("modules/main");
    $Modules_Menus = scandir("modules/menus");
    $Modules_Models = scandir("modules/analysis");
//Nur Schleife starten, wenn im Verzeichniss auch Dateien zum Einlesen da sind
if($Modules_Main !== FALSE)     
    {

        for($i=2;$i<count($Modules_Main);$i++)  //Erst bei 2 starten, da die ersten beiden Arrayeintrge nichts ntzliches enthalten
            {
                if(stristr($Modules_Main[$i],".php") !== FALSE && stristr($Modules_Main[$i],"\~") === FALSE) {include_once("modules/main/".$Modules_Main[$i]);}    //PHP-Datei?
            }

    }
if($Modules_Menus !== FALSE)     
    {
        for($a=2;$a<count($Modules_Menus);$a++)
            {
                if(stristr($Modules_Menus[$a],".php") !== FALSE && stristr($Modules_Menus[$a],"\~") === FALSE) {include_once("modules/menus/".$Modules_Menus[$a]);}    
            }
    }
if($Modules_Models !== FALSE)     
    {
        for($b=2;$b<count($Modules_Models);$b++)
            {
                if(stristr($Modules_Models[$b],".php") !== FALSE && stristr($Modules_Models[$b],"\~") === FALSE) {include_once("modules/analysis/".$Modules_Models[$b]);}    
            }
    }

/*Daten ber geladene Module in Session-Arrays bertragen*/
$_SESSION["Modules_Main"]   = $Modules_Main;
$_SESSION["Modules_Menus"]  = $Modules_Menus;
$_SESSION["Modules_Models"] = $Modules_Models;
$_SESSION["Modules_Classes"] = get_declared_classes();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
     <meta http-equiv="content-type" content="text/html; charset=ISO-8859-1">
     <?php 
            echo("     <title>".PROGRAMM." ".MAJOR_RELEASE.".".MINOR_RELEASE.".".PATCH_LEVEL."</title>\n");
            $Css_Sheets = scandir("css");
            if($Css_Sheets !== FALSE)     
                {
                    for($i=2;$i<count($Css_Sheets);$i++)
                        {
                            if(stristr($Css_Sheets[$i],".css") !== FALSE) {echo("     <link rel=\"stylesheet\" type=\"text/css\" href=\"css/".$Css_Sheets[$i]."\">\n");} //CSS-Datei?-->Einbinden!    
                        }
                }
     ?>
     <!-- Favicon fr alle/ IE-->
     <link rel="icon" href="gfx/favicon.ico" type="image/x-icon">
     <link rel="shortcut icon" href="gfx/favicon.ico" type="image/x-icon">
     <script type="text/javascript">
          window.setInterval("scrolldown()",1);
          function scrolldown()
              {
                  var logdivs = window.document.getElementsByName("logdiv");
                  for (i=0;i<logdivs.length;i++)
                      {
                          //Alle Logdivs automatisch nach unten scrollen
                          logdivs.item(i).scrollTop = logdivs.item(i).scrollHeight;
                      }
              }
     </script>
</head>
<body>   
<?php
/*Beim Wiederaufruf( = Aktualisierung der Seite) werden alle an die Seite per "post" bergebenen Daten geprft*/
control_submit();
/*--------Programm starten & Anzeige aktualisieren------------*/
show_main();
?>
</body>
</html>
