<?php
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

//Stellt die Kommunikation zwischen den Standart-Analysemodulen und der c++-Implementierung makergaulxx her
class cl_com_ds
    {
        //Namen der verschiedenen, kompilierten Binarys
        const WINDOWS_32_I686 = "makergaulxx-32-i686-win32.exe";
        const LINUX_32_I686 = "makergaulxx-32-i686-linux";
	const WINDOWS_64_I686 = "makergaulxx-32-i686-win32.exe";	//Momentan noch keine 64-bit-Version kompilliert!
        const LINUX_64_I686 = "makergaulxx-32-i686-linux";		//Momentan noch keine 64-bit-Version kompilliert!
        
        const STAT_WELL = "Well [";
        const STAT_LOOP = "] Lp. [";
        const STAT_ROUND= "] Rd. [";
        const STAT_RANGE = "] | Actual: ";
        const STAT_RESULT = " Best: ";
        const STAT_WORKING = " calculation running......";
        
        const STREAM_ERROR_NOBIN = "No executable file could be found.";
        const STREAM_ERROR_NOSTART = "Unable to launch application.";
        const STREAM_ERROR_SYSTEM = "The following system error occurred while executing the program: </br>";
        const STREAM_ERROR_SELECT = "Stream can not be read.";
        const STREAM_TEXT_END = "Finished";
        const TEXT_NOT_VALID = "Limit value violation";
        
        private $OS = 0;                    //Speichert den Betriebssystem-String
        private $Cpu = 0;                   //Speichert den CPU-String (=Systemarchitektur, wichtig, um die richtigen Binarys auszusuchen!)
	
	private $Execpath = 0;              //Ausfhrungspfad der Entsprechenden Binary + zu bergebende Parameter       
        private $Well = 0;                  //Wellnummer, in die Ergebnisse gespeichert werden
        private $Res = 0;                   //Anzahl Ergebnissparameter
        private $Stat_Line = array(4);      //Array mit Inhalten der aktuellen Statuszeile. [0] = Loops, [1] = Rounds, [2] = aktueller Fitness-Wert, [3] = bester Fitness-Wert
        private $Computed_Value = array();  //Zwischenspeicher fr die berechneten Modellwerte
        private $Results = array();         //Zwischenspeicher fr die Ergebnissparameter
        private $Pipes = 0;                 //Speichert die gestarteten Prozess-Handles
        private $Process = 0;               //Speichert den gestarteten Prozess
	private $Check_Stream = FALSE;	    //Der zu berprfende Stream
	private $Finished = FALSE;	    //Anzeige, ob Analyse fertig oder nicht
        private $Borders = Array();         //Speichert Grenzwerte der Parameter zur spteren Kontrolle des Ergebnisses 
        private $Last_Loop = 1;             //Speichert die Nummer des letzten Loops, der ber die Statuszeile ausgegeben wurde
        private $New_Well = TRUE;              //Wurde ein neues Well angefangen?
        private $Message = 1;               //Ausgabemodus.0 = Nur neues Well, 1 = nur jeden Loop, 2 = jeden Cycle
        //Bei Initialisierung des Objekts CPU-Architektur und das Betriebssystem bestimmen*/
        public function __construct()
            {
                $this->OS = php_uname("s");
                $this->Cpu = php_uname("m");
            }
            
         //Prozess wird bei Zerstrung des Objektes in jedem Fall beendet!*/
        public function __destruct()
            {
			if(is_resource($this->Process))//berhaupt Prozess geladen
                		{ 
                                //Das gestartete Programm sollte Betriebssystemspezifisch mglichst sicher beendet werden (insb. Windows-Probleme)
                                if(is_resource($this->Pipes[1]))
                                    {
                                        fclose($this->Pipes[0]);      //Alle Handles schlieen
                                        fclose($this->Pipes[1]);
                                        fclose($this->Pipes[2]);
                                    }
                                proc_terminate($this->Process);       //Prozess beenden
                                
                                //Da das aber unter Windows nicht sicher funktioniert...
                                if(stristr($this->OS, "Windows") !== FALSE)
                                    {
                                       $proc_status = proc_get_status($this->Process);
                                       $proc_status["pid"];
                                       @shell_exec("taskkill /PID ".$proc_status["pid"]." /T /F");  //...wird ber die Shell der Abbruch erzwungen! (Silent; keine Fehlermeldung, wenn proc_terminate schon erfolgreich war)
                                    }
                		}       
            }   
	//Abhngig von CPU-Architektur und Betriebssystem des Servers die zu verwendende Binary auswhlen*/
        public function setbinary()
            {
                $this->OS = php_uname("s");
                $this->Cpu = php_uname("m");
		if(preg_match("#\i[0-9]86#",$this->Cpu) !== FALSE) {$this->Cpu = "x86_32";}	//Alle x86-Modelle durch x86_32 ersetzen
		else if(strstr("x86_64",$this->Cpu) !== FALSE) {$this->Cpu = "x86_64";}		//Alle x86_64-Modelle durch x86_64 ersetzen
		if(stristr($this->OS, "Windows") !== FALSE)		//Variante 1: Windows-System: .exe benutzen
			{
				if($this->Cpu == "x86_32") {$this->Execpath = exec_getpath().self::WINDOWS_32_I686;}		//32-Bit-System?
				elseif($this->Cpu == "x86_64") {$this->Execpath = exec_getpath().self::WINDOWS_64_I686;}	//64-Bit-System?
				else{return(FALSE);}
			} 
                elseif(stristr($this->OS, "Linux") !== FALSE)		//Variante 2: Linux-Kompilierung benutzen
			{
				if($this->Cpu == "x86_32") {$this->Execpath = exec_getpath().self::LINUX_32_I686;}		//32-Bit-System?
				elseif($this->Cpu == "x86_64") {$this->Execpath = exec_getpath().self::LINUX_64_I686;}		//64-Bit-System?
				else{return(FALSE);}
			} 
                else{return(FALSE);}       //Letzte Variante (Kein erkanntes System): Abbrechen (php-Implementierung wird verwendet)
            }
            
        //Analyse starten
        //ACHTUNG: Die nachgeschaltete, ausfhrbare Datei (*exe bei Windows) fhrt KEINE prfung der einzelnen Messwerte durch, ob sie in die Analyse miteinzubeziehen sind. dies muss vorher in *php geschehen!
        public function run_analysis($par_well, $par_analysis, $par_res, $par_array_borders, $par_array_fix, $par_array_included_values, $par_loops, $par_rounds, $par_ref, $par_exp, $par_con, $par_step_1, $par_step_2, $par_step_3, $par_prec, $par_wdh, $par_message = 0)
            { 
               	if($this->setbinary() === FALSE) {return(FALSE);}		//Kein passendes Programm gefunden                                           
                if(is_executable($this->Execpath) && is_file($this->Execpath))  //Ist die entsprechende .exe / Bin vorhanden?
                    {
                        $this->Well = $par_well;  //Wellnummer speichern (fr Ergebnissbergabe an Platte wichtig)
                        $this->Res = $par_res;    //Anzahl der Ergebnissparameter speichern (fr Ergebnissbergabe an Platte wichtig)
                        $this->Borders = $par_array_borders; //Grenzwertarray speichern (zur spteren Kontrolle wichtig)
                        $this->Message = $par_message;  //Protokollmodus minimal oder mittel (maximal nicht verfgbar) 
                        if(is_array($par_array_fix)) {$par_fix = count($par_array_fix);}      //Fixwerte bergeben? Array zhlen!
                        else{$par_fix = -1;}                                                  //Ansonsten Fixwert auf -1 setzen (signalisiert makergaulxx, dass keine Fixwerte vorhanden sind)
                        //String, der die an das Programm zu bergebenden Parameter enthlt. Trennung der Parameter durch Leerzeichen " "
                        $argument = " -run ";
                        $argument = $argument.$par_res." ";                         //Erster Wert: Anzahl Ergebnissparameter (inkl. Fitness-Wert)
                        $argument = $argument.count($par_array_included_values)." ";//Zweiter Wert: Anzahl Messwerte (berechnet aus der Gre des Arrays der bergebenen Messwerte) 
                        $argument = $argument.$par_fix." ";                         //Dritter Wert: Wiederholungen (Loops)
                        $argument = $argument.$par_loops." ";                       //Vierter Wert: Wiederholungen (Loops)
                        $argument = $argument.$par_rounds." ";                      //Fnfter Wert: Durchgnge (Rounds)
                        $argument = $argument.$par_ref." ";                         //Sechster Wert: Reflexionsfaktor
                        $argument = $argument.$par_exp." ";                         //Siebter Wert: Expansionsfaktor
                        $argument = $argument.$par_con." ";                         //Achter Wert: Kontraktionsfaktor
                        $argument = $argument.$par_step_1." ";                      //Neunter Wert: Zwischenwert Fitness 1
                        $argument = $argument.$par_step_2." ";                      //Zehnter Wert: Zwischenwert Fitness 2
                        $argument = $argument.$par_step_3." ";                      //11. Wert: Zwischenwert Fitness 3
                        $argument = $argument.$par_prec." ";                        //12. Wert: Zielwert Fitness
                        $argument = $argument.$par_wdh." ";                         //13: Wdh.-Abbrecher (wird Momentan zwar bergeben, jedoch nicht benutzt)
                        $argument = $argument.$par_analysis." ";                    //14: Gewhlte Analysefunktion

                        //Zusammenbau des Strings mit den zu bergebenden Parametern: Grenzwerte
                        for($i = 0; $i < count($par_array_borders); $i++)
                            {
                                $argument = $argument.$par_array_borders[$i][0]." ";  //15. bis x. Unterer Grenzwert Parameter i
                                $argument = $argument.$par_array_borders[$i][1]." ";  //16. bis x+1. Oberer Grenzwert Parameter i 
                            }
                        //Zusammenbau des Strings mit den zu bergebenden Parametern: Messwerte
                        for($i = 0; $i < count($par_array_included_values); $i++)
                            {
                                if(!is_numeric($par_array_included_values[$i])){return(FALSE);}   //Nur numerische Werte als Parameter zugelassen!            
                                $argument = $argument.$par_array_included_values[$i]." ";         //x+1. bis x+n. Messwert i
                            }
                        //Zusammenbau des Strings mit den zu bergebenden Parametern: Fixwerte (nur wenn vorhanden!)
                        if($par_fix > 0)
                            {
                                for($i = 0; $i < $par_fix; $i++)
                                    {
                                        if(!is_numeric($par_array_included_values[$i])){return(FALSE);}   //Nur numerische Werte als Fixwerte zugelassen!            
                                        $argument = $argument.$par_array_fix[$i]." ";         //x+n. bis ende Fixwert i
                                    }
                            }
                            
                        $descriptorspec = array(
                                                   0 => array("pipe", "r"),  // STDIN ist ein Stream, von dem das Child liest (= die gestartete Anwendung)
                                                   1 => array("pipe", "w"),  // STDOUT ist ein Stream, in den das Child schreibt
                                                   2 => array("pipe", "a")   // STDERR ist ein Stream, in den geschrieben wird
                                                );
                        $other_options = array("suppress_errors"=>FALSE,"bypass_shell"=>TRUE);          //Bypass_shell, da sonst die Prozess-ID von cmd.exe statt die von makalysis.exe gespeichert wird (Wichtig zum Prozess-beenden unter Windows!)
                        $this->Process = proc_open($this->Execpath.$argument,$descriptorspec,$this->Pipes,NULL,NULL,$other_options);    //Prozess starten
                        if($this->Process !== FALSE) //Stream mit den vorbereiteten Parametern ffnen
                            {
                                stream_set_blocking($this->Pipes[1],0); 

                                $watch_read = array($this->Pipes[1]); //Arrays der Pipes in berwachungsarrays eintragen
                                $nullify = NULL;                      //Null, fr uninteressante Streams
                                $break = 0;
                                $endstring = "";                //Variable, die unvollstndige Rckgabewerte am Ende des Streams speichert (Vollstndige Felder sind durch ";" begrenzt.)
                                while($break != 10)             //Stream bei Inaktivitt max. 10 Sekunden beobachten
                                    {
                                        if($this->Finished === TRUE) {break;}
					$this->Check_Stream = @stream_select($watch_read,$nullify,$nullify,1);            //Den normalen Ausgabestream berwachen		

                                        if($this->Check_Stream === FALSE)                                                 //Fehler bei Stream-Select? Abbruch! 
                                            {
                                                echo(self::STREAM_ERROR_SELECT);
                                                break; 
                                            }                                                                
                                        else if($this->Check_Stream == 0) {$break ++;}                                    //Nichts passiert? Abbruchvariable eins hochzhlen!
                                        else                                                                        //Ansonsten Stream verarbeiten
                                            {
                                                $streamstring = $endstring.fread($this->Pipes[1],1000);             //Das Ende des letzten Stream-Strings vor den Aktuellen kopieren
                                                $last_semi = strrpos($streamstring,";");                            //Das letzte im Stream-String enthaltene Trennzeichen bestimmen    
                                                if($last_semi === FALSE)
                                                    {                                                               //Wenn kein Semikolon da war, den ganzen Stream-String als Endstring verwenden   
                                                        $endstring = $streamstring;                                 //Das Ende des Streams (meist unvollstndig, da nicht synchron mit Programmausgabe eingelesen) fr den nchsten Read-Vorgang speichern
                                                    }
                                                else
                                                    {                                                               //Wenn Semikolon da war, das mitabschneiden  
                                                        $endstring = substr($streamstring,$last_semi+1);            //Das Ende des Streams (meist unvollstndig, da nicht synchron mit Programmausgabe eingelesen) fr den nchsten Read-Vorgang speichern
                                                    }
                                                $streamstring = substr($streamstring,0,$last_semi);                 //Das letzte Feld abschneiden (meist unvollstndig)
                                                $this->search_in_stream($streamstring);	    		    	    //Den eingelesenen String nach brauchbaren Daten durchsuchen. Gibt FALSE zurck, wenn makergaulxx FINISHED signalisiert.
                                            } 
                                    }
                                echo(self::STREAM_TEXT_END); 
                                return(TRUE);                                                                       //Analyse wurde erfolgreich abgeschlossen                           
                            }
                        else
                            {
                                echo(self::STREAM_ERROR_NOSTART);           
                                return(FALSE);                                                                      //Mit Fehler abbrechen (Signal wird in cl_mak und cl_MAKERGAUL benutzt, um auf *.php-implementierte Analyse umzuschalten)                                          
                            }
                    }
                else  //Datei nicht Ausfhrbar? Abbrechen
                    {
                        echo(self::STREAM_ERROR_NOBIN);           
                        return(FALSE);                        //Mit Fehler abbrechen (Signal wird in cl_mak und cl_MAKERGAUL benutzt, um auf *.php-implementierte Analyse umzuschalten)        
                    }
            }
            
        private function search_in_stream($par_string)
            {
                //Anknpfungspunkt an den fortlaufenden Session-Array finden, der die Informationen des externen Programms aufnimmt
                //$next = count($_SESSION["Cl_Makergaul"]["Exec_Line"]);
                //String in Array zerlegen
//echo($par_string);
                $information = explode(";",$par_string);
                $end = count($information); 
                //Zweiter Schritt:Information in Daten- und Zahlenteil zerlegen
                for($i = 0; $i < count($information); $i++)
                    {
                        $data_line = explode("#",$information[$i]);  				//Ist in der Information eine gltige Datenzeile vorhanden?
                        if(count($data_line)<2)continue;             				//Kein ordentlicher zweiteiliger Eintrag? Abbrechen, weiterzhlen
			if(strpos($data_line[0],"FINISHED") !== FALSE){$this->Finished = TRUE;} //Ist die Analyse zu Ende? Beenden!
                        if(strpos($data_line[0],"NUM") !== FALSE) {$data_line[1] = $this-> build_number($data_line[1]);}  	//Wird Zahl zurckgegeben? Kommazahlen wieder zusammensetzen!
                        if(strpos($data_line[0],"STAT_LOOP") !== FALSE) {$this->Stat_Line[0] = $data_line[1];}          	//Statuszeileneintrge erkennen und zusammenfgen
                        else if(strpos($data_line[0],"STAT_ROUND") !== FALSE) {$this->Stat_Line[1] = $data_line[1];}
                        else if(strpos($data_line[0],"STAT_RANGE") !== FALSE) {$this->Stat_Line[2] = $data_line[1];}
                        else if(strpos($data_line[0],"STAT_RESULT") !== FALSE) {$this->Stat_Line[3] = $data_line[1];}
                        $this->send_status();                                                                           	//Fertige Statuszeilen Anzeigen
                        if(strpos($data_line[0],"END_RESULTS") !== FALSE) {$this->send_results();}                    		//Neuer Ergebnisblock? Alten abschicken und in $_SESSION speichern! 
                        if(strpos($data_line[0],"RESULT_PAR") !== FALSE) {$this->Results[filter_var($data_line[0],FILTER_SANITIZE_NUMBER_INT)] = $data_line[1];}          	//Neuer Ergebnissparameter-Eintrag? Speichern! (Richtige Position wird durch filter_var von dataline[0] bestimmt)
                        if(strpos($data_line[0],"COMPUTED_PAR") !== FALSE) {$this->Computed_Value[filter_var($data_line[0],FILTER_SANITIZE_NUMBER_INT)] = $data_line[1];}   	//Neuer Modellwert-Eintrag? Speichern! (Richtige Position wird durch filter_var von dataline[0] bestimmt)
                    }    
            }
        //Daten direkt in Session-Array schreiben (Achtung! In aufrufendem Analyseobjekt dafr sorgen, dass nach einer cl_com_ds-Analyse nicht die Session-Array-Ergebnisse mit den Defaultwerten der PHP-Implementierung der Analyse berschrieben werden!)
        private function send_results()
            {
                if($this->Results[1] < $this->Borders[0][0] || $this->Results[1] > $this->Borders[0][1])     //Prfen, ob der zurckgegebenen DNA-Wert im gltigen Bereich liegt und erst danach in $_SESSION-Array schreiben     
                            {
                                $_SESSION["Plate_Data"][$this->Well]["Results"][0]["Value"] = self::TEXT_NOT_VALID;
                            }
                else {$_SESSION["Plate_Data"][$this->Well]["Results"][0]["Value"] = $this->Results[1];}      //Result 1 = DNA
                
                $_SESSION["Plate_Data"][$this->Well]["Results"][1]["Value"] = $this->Results[0];      //Result 0 = Fitnesswert
                
                for($i = 2; $i < $this->Res; $i++)
                    {
                        if($this->Results[$i] < $this->Borders[$i-1][0] || $this->Results[$i] > $this->Borders[$i-1][1])     //Prfen, ob die zurckgegebenen Werte im gltigen Bereich liegen und erst danach in $_SESSION-Array schreiben     
                            {
                                $_SESSION["Plate_Data"][$this->Well]["Results"][$i]["Value"] = self::TEXT_NOT_VALID."(".$this->Results[$i]."|".$this->Borders[$i-1][0]."|".$this->Borders[$i-1][1].")";
                                $_SESSION["Plate_Data"][$this->Well]["Results"][0]["Value"] = self::TEXT_NOT_VALID;
                            }
                        else
                            {
                                $_SESSION["Plate_Data"][$this->Well]["Results"][$i]["Value"] = $this->Results[$i];      //Alle anderen Result-Werte sind symetrisch zu Platten-Result-Werten
                            }
                    }
                $_SESSION["Plate_Data"][$this->Well]["Computed_Data"] = $this->Computed_Value;        //Modellwerte speichern
             
                $this->Computed_Value = array();        //Zwischenspeicherarrays zurcksetzen fr neue Ergebnisse
                $this->Results = array();
            }    
            
        private function send_status()
            {
                if(!empty($this->Stat_Line[3]) && $this->Message == 2) //Ist der Ausgabearray komplett gefllt und der Protokollmodus auf maximal??
                    {
                        echo(self::STAT_WELL.$this->Well.self::STAT_LOOP.$this->Stat_Line[0].self::STAT_ROUND.$this->Stat_Line[1].self::STAT_RANGE.$this->Stat_Line[2].self::STAT_RESULT.$this->Stat_Line[3]."</br>"); //Statuszeile Ausgeben (Well, Loop, Cycle, aktuellerPunkt, bester Punkt)
                        foreach($this->Stat_Line as &$value) {$value = "";}    //Alle Eintrge lschen
                        flush();
                    }
                else if(!empty($this->Stat_Line[3]) && $this->Message == 1 && $this->Stat_Line[0] > $this->Last_Loop) //Ansonsten: ist ein neuer Loop angebrochen & der Protokollmodus auf normal & der Ausgabearray komplett gefllt??
                    {
			                  $this->Last_Loop = $this->Stat_Line[0];                 //Loop als angezeigt speichern
                        echo(self::STAT_WELL.$this->Well.self::STAT_LOOP.$this->Stat_Line[0]."]".self::STAT_RESULT.$this->Stat_Line[3]."</br>"); //Statuszeile Ausgeben (Nur Well, Loop und Result)
                        foreach($this->Stat_Line as &$value) {$value = "";}     //Alle Eintrge lschen
                        flush();
                    }  
                else if($this->Message == 0 && $this->New_Well !== FALSE) //Protokollmodus auf minimal: Anfangsstatus!
                    {
                        echo(self::STAT_WELL.$this->Well.self::STAT_WORKING."</br>"); //Statuszeile Ausgeben (Nur Well)
                        $this->New_Well = FALSE;
                        flush();
                    }  
                else if($this->Message == 0 && !empty($this->Stat_Line[3]) && $this->Stat_Line[0] != $this->Last_Loop)
                    {
			                  $this->Last_Loop = $this->Stat_Line[0];
                        echo(self::STAT_WELL.$this->Well."] ...</br>"); 	//Statuszeile Ausgeben (Nur "-")
                        foreach($this->Stat_Line as &$value) {$value = "";}     //Alle Eintrge lschen
                        flush();
                    } 
            }
            
        private function build_number($par_string)
            {
                if(!is_numeric($par_string)) {return(FALSE);} //Ist der String berhaupt eine Zahl?
		else{return($par_string);}
		/* NICHT MEHR BENTIGT, METHODE UM FLOATS AUS EXPONENT UND STRING ZUSAMMENZUSETZEN (FEHLERANFLLIG)
                $a = stripos($par_string,"E");                //Ist der String eine Kommazahl?               
                if(($a === FALSE)){return($par_string);}      //Keine? String so zurckgeben
                
                $vor = substr($par_string,$a+1);              //Anzahl Vorkommastellen bestimmen
                $sign = "";
                if(strpos($par_string,"-") === 0)
                    {
                        $par_string = substr($par_string,1);                      //negative Zahl? Vorzeichen wegschneiden... 
                        $sign = "-";                                              //...spter wieder anfgen...
                        $a = $a-1;                                                //...und $a an die verkrzte Lnge anpassen
                    }
                if($vor > 0)  //1 oder mehr Vorkommastellen (Ex)
                    {
                        $zwischenerg = substr($par_string,0,$a);
                        if(strlen($zwischenerg) < $vor)                           //Mehr Vorkommastellen als Zahlen von 1-9 vorhanden? mit 0 auffllen
                            {
                                $result = $sign.$zwischenerg.str_repeat("0",abs($vor-strlen($zwischenerg)));
                                return($result);
                            }
                        elseif(strlen($zwischenerg) == $vor)                      //Genau so viele Vorkommastellen wie Zahlenlnge? keine Kommazahl!
                            {
                                $result = $sign.$zwischenerg;
                                return($result);
                            }
                        $result = $sign.substr($par_string,0,$vor).".".substr($par_string,$vor,$a-$vor); //Ansonsten Komma an die richtige Stelle des Zahlenstrings setzen
                    }
                else if($vor == 0) //keine Vorkommastelle (E0)
                    {
                        $result = $sign."0.".substr($par_string,0,$a); //Zahlenstring zusammensetzen
                    }
                else if($vor < 0) //Nachkommastellen mssen mit 0 Aufgefllt werden (E-x)
                    {
                        $vor = str_repeat("0",abs($vor)); //Anzahl Vorkommastellen bestimmen ("0" wird $vor-mal wiederholt)
                        $result = $sign."0.".$vor.substr($par_string,0,$a); //Zahlenstring zusammensetzen
                    }                
                    
                if(strlen($result)>20){$result = substr($result,0,20);}    //Zahl ggf krzen
                return($result);
		*/
            }
    }
