<?php
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

/*Script zum Wechseln von Modulen*/
/*In diesem Script knnen nicht vorhandene Klassennamen auftauchen, daher wird vor dem aufrufen von static-methoden IMMER erst auf Klassenexistenz geprft*/
/*Erstellt das HTML-Gerst des Analyse-Mens*/
class cl_modulechange
{
    //The menu texts are defined as constants, so that an adjustment in other language is fast possible
    const TEXT_MODULECHANGE = "cl_modulechange";
    const TEXT_MODULE_SETTINGS = "Change modules...";
    const TEXT_MODULE_TITLE = "Selection of modul";
    const TEXT_MODULE_CHANGE = "Change";
    const TEXT_ANALYSIS_MODULE = "Change analysis module:";
    const TEXT_UPLOAD_MODULE = "Change upload module:";
    const TEXT_IMPORT_MODULE = "Change import module:";
    const TEXT_SAVE_MODULE = "Change export module:";
    const TEXT_CANCEL = "Cancel";
    const TEXT_ACCEPT = "Assume";
    const TEXT_ERROR = "The adjustment module required by the selected analysis module is not available.";
    //The class name prefixes that are characteristic for the respective class
    const CLASS_PREFIX_ANALYSIS = "cl_analysis";
    const CLASS_PREFIX_UPLOAD = "cl_upload";
    const CLASS_PREFIX_IMPORT = "cl_import";
    const CLASS_PREFIX_SAVE = "cl_save";
 
   
   //WICHTIG: In jeder Modulechange-Klasse ntig (Wird von main beim ersten Start des Programms aufgerufen)
    public static function firststart()
         {
              /*Initialisierung der vom Objekt eingefhrten $SESSION-Variablen*/ 
              $_SESSION["Cl_Modulechange"]["Menu"] = 1;   //Men=Einstellungsbutton
         } 
   //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim wechsel auf ein anderes Modul aufgerufen)
   public static function unload()
         {
              /*Lschen der vom Objekt eingefhrten $SESSION-Variablen*/ 
              unset($_SESSION["Cl_Modulechange"]); 
         } 
   
   //WICHTIG: In jeder Modulechange-Klasse ntig (Wird von main.php zur Einblendung des Optionsmens aufgerufen)     
    public function on_request()/*Funktion berprft die vom Formular bertragenen Daten*/
         {
              //Untermen aufrufen??
              if(isset($_REQUEST["Cl_Modulechange"]["Submenu"]))
                  {
                      $_SESSION["Cl_Modulechange"]["Menu"] = 2; //Button ausblenden (wird in show_menu() geregelt)
                      $_SESSION["Main"]["Show"] = self::TEXT_MODULECHANGE;
                  }
              //Standart im Untermen-Modus: Ansicht aktualisieren und im Untermen bleiben
              if($_SESSION["Cl_Modulechange"]["Menu"] == 2){$_SESSION["Main"]["Show"] = self::TEXT_MODULECHANGE;}
              //Alle Module aktualisiert?
              if(isset($_REQUEST["Cl_Modulechange"]["Acceptmenu"]))
                  {
                      //Analysismodul gendert?
                      $Analysis_Compare = htmlentities($_REQUEST["Cl_Modulechange"]["Analysis_Module"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");
                      if($Analysis_Compare != $_SESSION["Module"]["Analysis"]["Type"]) {$_REQUEST["Cl_Modulechange"]["Analysis_Button"] = $Analysis_Compare;}
                      //Uploadmodul gendert?
                      $Upload_Compare = htmlentities($_REQUEST["Cl_Modulechange"]["Upload_Module"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");
                      if($Upload_Compare != $_SESSION["Module"]["Upload"]["Type"]) {$_REQUEST["Cl_Modulechange"]["Upload_Button"] = $Upload_Compare;}
                      //Savemodul gendert?
                      $Save_Compare = htmlentities($_REQUEST["Cl_Modulechange"]["Save_Module"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");
                      if($Save_Compare != $_SESSION["Module"]["Save"]["Type"]) {$_REQUEST["Cl_Modulechange"]["Save_Button"] = $Save_Compare;}
                      //Importmodul gendert?
                      $Import_Compare = htmlentities($_REQUEST["Cl_Modulechange"]["Import_Module"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");
                      if($Import_Compare != $_SESSION["Module"]["Import"]["Type"]) {$_REQUEST["Cl_Modulechange"]["Import_Button"] = $Import_Compare;}

                      $_SESSION["Cl_Modulechange"]["Menu"] = 1;  //Hauptmen-Modus (show_menu(): Modulechange-Button wird sichtbar, Untermen verschwindet)
                      $_SESSION["Main"]["Show"] = MAIN_MODE_ALL; //Ansicht aktualisieren
                  }
              //Analysemodul aktualisiert?
              if(isset($_REQUEST["Cl_Modulechange"]["Analysis_Button"]))
                  {
                      $Analysis_Compare = htmlentities($_REQUEST["Cl_Modulechange"]["Analysis_Module"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"); 
                      //Ist das Analysemodul berhaupt gendert worden?
                      if($Analysis_Compare != $_SESSION["Module"]["Analysis"]["Type"]) 
                          {
                              load_module($_SESSION["Module"]["Analysis"]["Type"],$Analysis_Compare);       //Zuerst neues Modul laden..
                              $_SESSION["Module"]["Plate"]["Active"]->reload_structure();                   //..dann Platte auf neue ["Result"]-Parameter vorbereiten                        
                          } 
                  }  
              //Updatemodul aktualisiert?
              if(isset($_REQUEST["Cl_Modulechange"]["Upload_Button"]))
                  {
                      $Upload_Compare = htmlentities($_REQUEST["Cl_Modulechange"]["Upload_Module"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"); 
                      //Ist das Uploadmodul berhaupt gendert worden?
                      if($Upload_Compare != $_SESSION["Module"]["Upload"]["Type"]) 
                          {
                              load_module($_SESSION["Module"]["Upload"]["Type"],$Upload_Compare,TRUE);      
                              $_SESSION["Module"]["Plate"]["Active"]->reload_structure();                   
                          }
                  }  
              //Importmodul aktualisiert?
              if(isset($_REQUEST["Cl_Modulechange"]["Import_Button"]))
                  {
                      $Import_Compare = htmlentities($_REQUEST["Cl_Modulechange"]["Import_Module"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"); 
                      //Ist das Analysemodul berhaupt gendert worden?
                      if($Import_Compare != $_SESSION["Module"]["Import"]["Type"]) 
                          {
                              load_module($_SESSION["Module"]["Import"]["Type"],$Import_Compare,TRUE);
                              $_SESSION["Module"]["Plate"]["Active"]->reload_structure();                   
                          }
                  } 
              //Savemodul aktualisiert?
              if(isset($_REQUEST["Cl_Modulechange"]["Save_Button"]))
                  {
                      $Save_Compare = htmlentities($_REQUEST["Cl_Modulechange"]["Save_Module"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"); 
                      //Ist das Analysemodul berhaupt gendert worden?
                      if($Save_Compare != $_SESSION["Module"]["Save"]["Type"]) 
                          {
                              load_module($_SESSION["Module"]["Save"]["Type"],$Save_Compare,TRUE);
                              $_SESSION["Module"]["Plate"]["Active"]->reload_structure();                 
                          }
                  } 
              //Zurch zum Hauptmen und abbrechen??
              if(isset($_REQUEST["Cl_Modulechange"]["Cancelmenu"]))
                  {
                      $_SESSION["Cl_Modulechange"]["Menu"] = 1;  //Hauptmen-Modus (show_menu(): Modulechange-Button wird sichtbar, Untermen verschwindet)
                      $_SESSION["Main"]["Show"] = MAIN_MODE_ALL; //Ansicht aktualisieren
                      
                  }  
         }
   
    //WICHTIG: In jeder Modulechange-Klasse ntig (Wird von main.php zur Einblendung des Optionsmens aufgerufen) 
    public function show_menu()
         {
         if($_SESSION["Cl_Modulechange"]["Menu"] == 1) //Fall 1: Hauptmen ->Button anzeigen, der ins Untermen fhrt
              {
                  echo("<div class=\"css_modulchange_menu\">\n");
                  echo("        <input class=\"css_modulechange_submenu_button\" name=\"Cl_Modulechange[Submenu]\" type=\"submit\" value=\"".self::TEXT_MODULE_SETTINGS."\">\n");
                  echo("</div>\n");
              }
         if($_SESSION["Cl_Modulechange"]["Menu"] == 2) //Fall 2: Untermen ->keinen Button anzeigen
              {
                  echo("    <div class=\"css_modulchange_submenu\">\n");
                  echo("        <p class=\"css_modulechange_title\">".self::TEXT_MODULE_TITLE."</p>\n");
                  //Selektionsmen Analysemodul
                  echo("        <p class=\"css_modulechange_text_1\">".self::TEXT_ANALYSIS_MODULE."</p>\n");
                  echo("        <select name=\"Cl_Modulechange[Analysis_Module]\" class=\"css_modulchange_analysis\" size=\"1\">\n");
                  echo("                <option value=\"".$_SESSION["Module"]["Analysis"]["Type"]."\">".$_SESSION["Module"]["Analysis"]["Type"]."</option>\n"); //Erster Eintrag: aktuell gewhltes Modul
                  for($i=0; $i<count($_SESSION["Modules_Classes"]); $i++)
                      {
                          if(stristr($_SESSION["Modules_Classes"][$i],self::CLASS_PREFIX_ANALYSIS) !== FALSE)
                              {
                                  echo("                <option value=\"".$_SESSION["Modules_Classes"][$i]."\">".$_SESSION["Modules_Classes"][$i]."</option>\n");
                              }     
                      }  
                  echo("        </select>\n"); 
                  echo("        <input class=\"css_modulchange_button_analysis\" name=\"Cl_Modulechange[Analysis_Button]\" type=\"submit\" value=\"".self::TEXT_MODULE_CHANGE."\">\n");
                  //Selektionsmen Uploadmodul
                  echo("        <p class=\"css_modulechange_text_2\">".self::TEXT_UPLOAD_MODULE."</p>\n");
                  echo("        <select name=\"Cl_Modulechange[Upload_Module]\" class=\"css_modulchange_upload\" size=\"1\">\n");
                  echo("                <option value=\"".$_SESSION["Module"]["Upload"]["Type"]."\">".$_SESSION["Module"]["Upload"]["Type"]."</option>\n"); //Erster Eintrag: aktuell gewhltes Modul
                  for($i=0; $i<count($_SESSION["Modules_Classes"]); $i++)
                      {
                          if(stristr($_SESSION["Modules_Classes"][$i],self::CLASS_PREFIX_UPLOAD) !== FALSE)
                              {
                                  echo("                <option value=\"".$_SESSION["Modules_Classes"][$i]."\">".$_SESSION["Modules_Classes"][$i]."</option>\n");
                              }     
                      }  
                  echo("        </select>\n"); 
                  echo("        <input class=\"css_modulchange_button_upload\" name=\"Cl_Modulechange[Upload_Button]\" type=\"submit\" value=\"".self::TEXT_MODULE_CHANGE."\">\n");
                  //Selektionsmen Importmodul
                  echo("        <p class=\"css_modulechange_text_3\">".self::TEXT_IMPORT_MODULE."</p>\n");
                  echo("        <select name=\"Cl_Modulechange[Import_Module]\" class=\"css_modulchange_import\" size=\"1\">\n");
                  echo("                <option value=\"".$_SESSION["Module"]["Import"]["Type"]."\">".$_SESSION["Module"]["Import"]["Type"]."</option>\n"); //Erster Eintrag: aktuell gewhltes Modul
                  for($i=0; $i<count($_SESSION["Modules_Classes"]); $i++)
                      {
                          if(stristr($_SESSION["Modules_Classes"][$i],self::CLASS_PREFIX_IMPORT) !== FALSE)
                              {
                                  echo("                <option value=\"".$_SESSION["Modules_Classes"][$i]."\">".$_SESSION["Modules_Classes"][$i]."</option>\n");
                              }     
                      }  
                  echo("        </select>\n"); 
                  echo("        <input class=\"css_modulchange_button_import\" name=\"Cl_Modulechange[Import_Button]\" type=\"submit\" value=\"".self::TEXT_MODULE_CHANGE."\">\n");    
                  //Selektionsmen Savemodul
                  echo("        <p class=\"css_modulechange_text_4\">".self::TEXT_SAVE_MODULE."</p>\n");
                  echo("        <select name=\"Cl_Modulechange[Save_Module]\" class=\"css_modulchange_save\" size=\"1\">\n");
                  echo("                <option value=\"".$_SESSION["Module"]["Save"]["Type"]."\">".$_SESSION["Module"]["Save"]["Type"]."</option>\n"); //Erster Eintrag: aktuell gewhltes Modul
                  for($i=0; $i<count($_SESSION["Modules_Classes"]); $i++)
                      {
                          if(stristr($_SESSION["Modules_Classes"][$i],self::CLASS_PREFIX_SAVE) !== FALSE)
                              {
                                  echo("                <option value=\"".$_SESSION["Modules_Classes"][$i]."\">".$_SESSION["Modules_Classes"][$i]."</option>\n");
                              }     
                      }  
                  echo("        </select>\n"); 
                  echo("        <input class=\"css_modulchange_button_save\" name=\"Cl_Modulechange[Save_Button]\" type=\"submit\" value=\"".self::TEXT_MODULE_CHANGE."\">\n"); 
                  //Button zum Verlassen des Mens ohne & mit speichern 
                  echo("        <input class=\"css_modulchange_cancel_button\" name=\"Cl_Modulechange[Cancelmenu]\" type=\"submit\" value=\"".self::TEXT_CANCEL."\">\n"); 
                  echo("        <input class=\"css_modulchange_accept_button\" name=\"Cl_Modulechange[Acceptmenu]\" type=\"submit\" value=\"".self::TEXT_ACCEPT."\">\n"); 
                  echo("    </div>\n");
              }
         }
        
} 
?>