<?php
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

/*Leerklasse, Grundlage fr alle cl_noanalysis-Fehlerklassen*/
class cl_noanalysis
{        
    const TEXT_NONE = "???";
    const NOSETTINGS_AE = "cl_nosettings_ae";
    const NOSETTINGS_SE = "cl_nosettings_se";
    //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim Wechsel auf ein anderes Modul aufgerufen)
    public static function unload()
         {
              /*Leer*/
         } 
    //WICHTIG: In jeder Klasse ntig. bertragene Daten aus Analyseformular kontrollieren (ACHTUNG: viele Global-Aufrufe sind mit @ versehen, da die entsprechenden Indizes je nach Formularaktion nicht vergeben sind!)     
    function on_request()/*Funktion berprft die vom Formular bertragenen Daten*/
         {
              /*Direkt zur Anzeige durchleiten*/
         }  
    //WICHTIG: Wird von jeder Analyseklasse bentigt. Aufruf erfolgt von cl_plate um den zu erstellenden Ergebnissarray der Platte an die Ausgabe des Analysemoduls anzupassen*/
    public static function result_pars()
        {
            //Namen und Defaultwerte der Parameter
            $ergebniss = array(0=>array("ID"=>self::TEXT_NONE,"Value"=>self::TEXT_NONE));
            return($ergebniss);
        }  
    //WICHTIG: In jeder Analyseklasse-Klasse ntig. Wird von Settings-Objekt aufgerufen und startet die Analyse.   
    public function run_analysis()
       {
            /*Leer*/
       } 
}

//gewnschtes Analysemodul nicht vorhanden?
class cl_noanalysis_ae extends cl_noanalysis
{        
    //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim Wechsel auf ein anderes Modul aufgerufen)
    public static function firststart()
         {
              load_module($_SESSION["Module"]["Settings"]["Type"],self::NOSETTINGS_AE,TRUE); //Fehlersettings laden
         } 
}

//gewnschtes Settingsmodul nicht vorhanden?
class cl_noanalysis_se extends cl_noanalysis
{        
    //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim Wechsel auf ein anderes Modul aufgerufen)
    public static function firststart()
         {
              load_module($_SESSION["Module"]["Settings"]["Type"],self::NOSETTINGS_SE,TRUE); //Fehlersettings laden
         } 
}

//#################################################################################################################################################################

/*Leerklasse, Grundlage fr alle cl_nosettings-Fehlerklassen*/
class cl_nosettings
{ 
    //WICHTIG: In jeder Klasse ntig     
    public static function firststart()
         {
              /*Leer*/
              
         }
    //WICHTIG: In jeder Settings-Klasse ntig (Kann vom gewhlten Analyseobjekt mit variabler Anzahl von Parametern aufgerufen werden, um die Voreinstellungen anzupassen)     
    public static function presets($a=NULL,$b=NULL,$c=NULL,$d=NULL,$e=NULL,$f=NULL,$g=NULL,$h=NULL,$i=NULL,$j=NULL)
         {
              /*Leer*/
         }
         
    //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim Wechsel auf ein anderes Modul aufgerufen)
    public static function unload()
         {
              /*Leer*/
         } 
    //WICHTIG: In jeder Klasse ntig. bertragene Daten aus Analyseformular kontrollieren (ACHTUNG: viele Global-Aufrufe sind mit @ versehen, da die entsprechenden Indizes je nach Formularaktion nicht vergeben sind!)     
    function on_request()/*Funktion berprft die vom Formular bertragenen Daten*/
         {
              /*Direkt zur Anzeige durchleiten*/
         }  
         
    //WICHTIG: In jeder Settings-Klasse ntig. Erzeugt Analysobjekt und startet die Analyse.   
    public function run_analysis()
         {
              /*Leer*/
         } 
} 

/*Fehlerklasse, die Anstelle eines fehlenden cl_settings-Objekt angezeigt wird*/
class cl_nosettings_se extends cl_nosettings
{
    //Die Mentexte werden als Konstanten definiert, damit eine Sprachanpassung schnell mglich ist
    const TEXT_TITLE = "Required settings module not avaliable.";
    const TEXT_ERROR = "The loaded analysis module requires a settings module wich is not installed at your system. Contact your system administrator for installing the missing module.";
        //WICHTIG: In jeder Settings-Klasse ntig (Wird von main.php zur Einblendung des Optionsmens aufgerufen) 
    public function show_menu()
         {
              echo("<div class=\"css_nosettings\">\n");
              echo("        <p class=\"css_nosettings_title\">".self::TEXT_TITLE."</p>\n");
              echo("        <p class=\"css_nosettings_error\">".self::TEXT_ERROR."</p>\n");
              echo("</div>\n");
         }
} 
/*Fehlerklasse, die Anstelle eines fehlenden cl_settings-Objekt angezeigt wird*/
class cl_nosettings_ae extends cl_nosettings
{
    //Die Mentexte werden als Konstanten definiert, damit eine Sprachanpassung schnell mglich ist
    const TEXT_TITLE = "Required Analysis module not avaliable.";
    const TEXT_ERROR = "The loaded data was processed by an analysis module which is not installed at your system. Choose another module or contact your system administrator for installing the missing one.";
    //WICHTIG: In jeder Settings-Klasse ntig (Wird von main.php zur Einblendung des Optionsmens aufgerufen) 
    public function show_menu()
         {
              echo("<div class=\"css_nosettings\">\n");
              echo("        <p class=\"css_nosettings_title\">".self::TEXT_TITLE."</p>\n");
              echo("        <p class=\"css_nosettings_error\">".self::TEXT_ERROR."</p>\n");
              echo("</div>\n");
         }
} 
?>