<?php
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

/*main.php*/
/*Leitet die Requests an die geladenen Module weiter und bndelt die entsthenden HTML-Mes in einer Anzeige*/
const MAIN_TEXT_NEWPLATE = "New Plate";
const MAIN_INT_MODULES = 8;
const MAIN_MODE_ALL = "MODE_ALL";
const MAIN_MODE_ANALYSIS = "MODE_ANALYSIS";
const MAIN_MODE_ERROR = "MODE_ERROR";
const MAIN_MODE_NONE = "MODE_NONE";
const MAIN_NOANALYSIS_SE = "cl_nosettings_se";  //Klasse, die geladen wird, wenn ein Analyseobjekt keine passende Settings-Klasse findet
const MAIN_NOANALYSIS_AE = "cl_nosettings_ae";  //Klasse, die geladen wird, wenn ein Analyseobjekt nicht verfgbar ist
/*Standartmodule*/
const MAIN_MODULE_ANALYSIS = "cl_analysis_MAKERGAUL";
const MAIN_MODULE_PLATE = "cl_Plate";
const MAIN_MODULE_MODULECHANGE = "cl_modulechange";
const MAIN_MODULE_SETTINGS = "cl_settings_ds";
const MAIN_MODULE_SAVE = "cl_save_default";
const MAIN_MODULE_UPLOAD = "cl_upload_default";
const MAIN_MODULE_IMPORT = "cl_import_default";
const MAIN_MODULE_NAMES = "cl_names_default";
const MAIN_MODULE_CHECKBOX = "cl_checkbox_default";
/*Konstanten zur Kommunikation mit der Platte*/
const MAIN_WELLS_ALL = "All_Wells";
const MAIN_RESULT_TYPE_FIRST = "DNA";
const MAIN_RESULT_TYPE_SECOND = "PRECISION";
const MAIN_RESULT_TYPE_OTHER = "OTHER";
const MAIN_REQUIREMENT_ERROR = "Required module not avaliable!";


function control_submit()/*Funktion berprft die vom Formular bertragenen Daten*/
     {
        //Anzeigesteuerung ["Main"] wird bei jedem Aufruf aktualisiert und neu gesetzt
        $_SESSION["Main"] = array("Show"=>0,"Error"=>"keiner"); 
        //Nicht mehr bentigte Analyseobjekte, die noch existieren knnten, lschen 
        if(isset($_SESSION["Module"]["Analysis"]["Active"])) unset($_SESSION["Module"]["Analysis"]["Active"]); 
       /*----STARTINITIALISIERUNG-----*/
       //Erster Seitenaufruf-->erst Sessionvariablen mit Standartwerten fllen, dann Objekte erstellen
        if(!isset($_SESSION["Start"])) 
            {
                $_SESSION["Start"] = 1;
                initialize_session_var();
                initialize_objects();
            }
        //Nachfolgender Seitenaufruf-->direkt Objekte initialisieren
        initialize_objects();    
       /*----$_REQUEST-Verarbeitung------*/
       //Prfen, ob Modulechange-Modul aufgerufen wurde 
       //WIRD ALS ERSTER REQUEST AUFGERUFEN, DAMIT DIE BRIGEN REQUESTS SCHON AN DIE GENDERTEN MODULE GEHEN!!!
       $_SESSION["Module"]["Modulechange"]["Active"]->on_request();
       //Prfen, ob Upload-Modul aufgerufen wurde
       $_SESSION["Module"]["Upload"]["Active"]->on_request();
       //Prfen, ob Check-Modul aufgerufen wurde
       $_SESSION["Module"]["Checkbox"]["Active"]->on_request();  
       //Prfen, ob Save-Modul aufgerufen wurde
       $_SESSION["Module"]["Save"]["Active"]->on_request(); 
       //Prfen, ob Import-Modul aufgerufen wurde
       $_SESSION["Module"]["Import"]["Active"]->on_request();    
       //Prfen, ob Import-Modul aufgerufen wurde
       $_SESSION["Module"]["Settings"]["Active"]->on_request(); 
       //Prfen, ob Well-Benennungsobjekt-Modul aufgerufen wurde
       $_SESSION["Module"]["Names"]["Active"]->on_request();      
     }  
/*Funktion regelt die Anzeige der Hauptseite (wird bei jeder Aktualisierung aufgerufen)*/
function show_main()
    {
        $analysis_namepos = strpos($_SESSION["Module"]["Analysis"]["Type"],"_",3); //Erst ab dem dritten Zeichen nach bindestrich suchen, damit "cl_" nicht erkannt wird
        $analysis_namepart = substr($_SESSION["Module"]["Analysis"]["Type"],$analysis_namepos+1);
        /*Alle Mens, die in show_main() eingebunden werden, haben als action ( = Ziel) ihrer Formularaufrufe durch <input-Elemente> "makergaul.php"*/
        echo("    <div class=\"css_logo\">\n");
        echo("        <div class=\"css_current_name\">".$analysis_namepart."</div>\n");
        echo("    </div>\n"); 
        echo("    <div class=\"css_plate\">\n"); 
        echo("        <form action=\"".$_SESSION["Mainfile"]."\" method=\"post\">\n");   
        /*Immer:Modulechange-Men anzeigen*/
        $_SESSION["Module"]["Modulechange"]["Active"]->show_menu();           

        /*Analyse gestartet?*/
        if($_SESSION["Main"]["Show"]  === MAIN_MODE_ANALYSIS)
            {
                /*1.Analysemen anzeigen*/
                $_SESSION["Module"]["Settings"]["Active"]->show_menu(); 
                /*2.Analyse starten*/  
                $_SESSION["Module"]["Settings"]["Active"]->run_analysis(); 
                /*3.Nach der Analyse alte Ansicht wiederherstellen*/   
                $_SESSION["Main"]["Show"] = MAIN_MODE_ALL;  //Nach abgeschlossener Analyse zu MAIN_MODE_ALL springen
            }
            
        /*Selektion gendert?/Werte aktualisiert?*/
        if($_SESSION["Main"]["Show"]  === MAIN_MODE_ALL)
            {
                /*1. Platte anzeigen*/
                $_SESSION["Module"]["Plate"]["Active"]->show_plate();
                /*2.Modulnderungs-Men anzeigen*/
                $_SESSION["Module"]["Modulechange"]["Active"]->show_menu(); 
                /*3.Save-Men anzeigen*/  
                $_SESSION["Module"]["Save"]["Active"]->show_menu(); 
                /*4.Auswahl-Men anzeigen*/ 
                $_SESSION["Module"]["Checkbox"]["Active"]->show_menu();
                /*5.Namennderungs-Men anzeigen*/
                $_SESSION["Module"]["Names"]["Active"]->show_menu(); 
                /*6. Analysemen anzeigen*/
                $_SESSION["Module"]["Settings"]["Active"]->show_menu();      
            }    
        /*Fehler Aufgetreten?*/
        elseif($_SESSION["Main"]["Show"]  === MAIN_MODE_ERROR)
            {
                /*1.Fehler anzeigen*/
                echo("    <div class=\"css_main_error\">\n");
                echo("        ".$_SESSION["Main"]["Error"]."\n");
                echo("    </div>\n");  
                /*2. Alle Module mit Standartwerten neu laden*/ 
                initialize_session_var(); 
            }
        /*Individuelle Menzusammensetzung*/
        /*mehrere Modulklassen werden im ["Main"]["Show"] String mittels | voneinander getrennt*/
        else
            {
                //Nachschauen, ob im String geladene Module eingebettet sind, die angezeigt werden sollen 
                $shown_modules = explode("|",$_SESSION["Main"]["Show"]);
                //Fr alle Modultypen durchgehen und bei Treffer das entsprechende aktive Objekt anzeigen
                for($a=0;$a<count($shown_modules);$a++)
                    { 
                              if(strcasecmp($shown_modules[$a],$_SESSION["Module"]["Settings"]["Type"]) == 0){$_SESSION["Module"]["Settings"]["Active"]->show_menu();}
                              elseif(strcasecmp($shown_modules[$a],$_SESSION["Module"]["Import"]["Type"]) == 0){$_SESSION["Module"]["Import"]["Active"]->show_menu();} 
                              elseif(strcasecmp($shown_modules[$a],$_SESSION["Module"]["Save"]["Type"]) == 0){$_SESSION["Module"]["Save"]["Active"]->show_menu();} 
                              elseif(strcasecmp($shown_modules[$a],$_SESSION["Module"]["Checkbox"]["Type"]) == 0){$_SESSION["Module"]["Checkbox"]["Active"]->show_menu();} 
                              elseif(strcasecmp($shown_modules[$a],$_SESSION["Module"]["Names"]["Type"]) == 0){$_SESSION["Module"]["Names"]["Active"]->show_menu();} 
                              elseif(strcasecmp($shown_modules[$a],$_SESSION["Module"]["Plate"]["Type"]) == 0){$_SESSION["Module"]["Plate"]["Active"]->show_plate();}       
                    }
            } 
        echo("        </form>\n");
        echo("    </div>\n");
        
        /*Am Schluss: immer Upload-Men anzeigen(Auerhalb der Platte, da mit eigenem <form> Ausgestattet --> Wrde sonst nur <form> der Platte bearbeiten und keine Datei hochladen knnen)*/
        $_SESSION["Module"]["Upload"]["Active"]->show_menu(); 
    }

     
/*Alle $_SESSION-Variablen auf Startwerte setzen*/
function initialize_session_var()
    {
        //Name des Scrips (z.B. ntig, falls "makergaul.php" z.B. in "index.php" umbenannt wurde)
        if(strpos(INDEXFILE,"\\")!== FALSE){$_SESSION["Mainfile"] = substr(INDEXFILE,strrpos(INDEXFILE,"\\")+1);}  //Windows-Pfad?
        if(strpos(INDEXFILE,"/")!== FALSE){$_SESSION["Mainfile"] = substr(INDEXFILE,strrpos(INDEXFILE,"/")+1);}  //UNIX-Pfad?
        //Modultypen
        $_SESSION["Module"]["Plate"]["Type"] = MAIN_MODULE_PLATE; 
        $_SESSION["Module"]["Analysis"]["Type"] = MAIN_MODULE_ANALYSIS;
        $_SESSION["Module"]["Settings"]["Type"] = MAIN_MODULE_SETTINGS;     //Als Defaultwert fr Setting wird eine Fehlerklasse geladen, die so lange erhalten bleibt, bis cl_analysis die gewnschte Settings-Klasse geladen hat. Falls das fehlschlgt wird die Fehlerklase angezeigt.
        $_SESSION["Module"]["Save"]["Type"] = MAIN_MODULE_SAVE;
        $_SESSION["Module"]["Upload"]["Type"] = MAIN_MODULE_UPLOAD;
        $_SESSION["Module"]["Import"]["Type"] = MAIN_MODULE_IMPORT;
        $_SESSION["Module"]["Checkbox"]["Type"] = MAIN_MODULE_CHECKBOX;
        $_SESSION["Module"]["Names"]["Type"] = MAIN_MODULE_NAMES;
        $_SESSION["Module"]["Modulechange"]["Type"] = MAIN_MODULE_MODULECHANGE;
        
        //Platte: Fakten
        $_SESSION["Plate_Facts"] = array("Area"=>96,"Rows"=>12, "Name"=>MAIN_TEXT_NEWPLATE);
        //Modulinitialisierung (Globals durch Klassen registrieren u..)
        //ACHTUNG: erst nach der Initialisierung der Globals des Hauptprogramms die Modulinitialisierung starten, da diese teilweise benutzt werden
        initialize_module_var();
    } 
/*Modulvariablen initialisieren (Noch vor Objekterstellung!)*/
function initialize_module_var()
    { 
        cl_Plate::prepare_plate();  //Platte: Datenarray aufbauen
        if(class_exists($_SESSION["Module"]["Analysis"]["Type"]) === TRUE) {$_SESSION["Module"]["Analysis"]["Type"]::firststart();} //Analysis_Type::firststart bestimmt auch Settings_Type::firststart!
        else{$_SESSION["Module"]["Analysis"]["Type"] = "cl_analysis_mak2";}
        if(class_exists($_SESSION["Module"]["Upload"]["Type"]) === TRUE) {$_SESSION["Module"]["Upload"]["Type"]::firststart();}
        else{$_SESSION["Module"]["Upload"]["Type"] = "cl_upload_default";}
        if(class_exists($_SESSION["Module"]["Checkbox"]["Type"]) === TRUE) {$_SESSION["Module"]["Checkbox"]["Type"]::firststart();}
        else{$_SESSION["Module"]["Checkbox"]["Type"] = "cl_checkbox_default";}
        if(class_exists($_SESSION["Module"]["Save"]["Type"]) === TRUE) {$_SESSION["Module"]["Save"]["Type"]::firststart();}
        else{$_SESSION["Module"]["Save"]["Type"] = "cl_save_default";}
        if(class_exists($_SESSION["Module"]["Import"]["Type"]) === TRUE) {$_SESSION["Module"]["Import"]["Type"]::firststart();}
        else{$_SESSION["Module"]["Import"]["Type"] = "cl_import_default";}
        if(class_exists($_SESSION["Module"]["Names"]["Type"]) === TRUE) {$_SESSION["Module"]["Names"]["Type"]::firststart();}
        else{$_SESSION["Module"]["Names"]["Type"] = "cl_names_default";}
        if(class_exists($_SESSION["Module"]["Modulechange"]["Type"]) === TRUE) {$_SESSION["Module"]["Modulechange"]["Type"]::firststart();} //Erst initialisieren, nachdem alle Standartmodule geladen sind
        else{$_SESSION["Module"]["Modulechange"]["Type"] = "cl_modulechange";}
    }   
/*Objekte initialisieren*/
function initialize_objects()
    {
        /*Module (= Objekte) erzeugen*/  
        $_SESSION["Module"]["Modulechange"]["Active"] = new $_SESSION["Module"]["Modulechange"]["Type"]; //Modulwechsel-Objekt initialisieren       
        $_SESSION["Module"]["Plate"]["Active"] = new $_SESSION["Module"]["Plate"]["Type"];             //Neue Platte erstellen (immer aus Klasse cl_Plate)
        $_SESSION["Module"]["Settings"]["Active"] = new $_SESSION["Module"]["Settings"]["Type"];//Neues Objekt mit Einstellungsoptionen zur Analyse erstellen. (Standart: Downhill-Simplex, wird von der Analyseklasse im register()-Aufruf als index[0] des zurckgegebenen Arrays bergeben)*/
        $_SESSION["Module"]["Save"]["Active"] = new $_SESSION["Module"]["Save"]["Type"];        //Save-Objekt initialisieren
        $_SESSION["Module"]["Upload"]["Active"] = new $_SESSION["Module"]["Upload"]["Type"];    //Upload-Objekt initialisieren 
        $_SESSION["Module"]["Import"]["Active"] = new $_SESSION["Module"]["Import"]["Type"];    //Upload-Objekt initialisieren 
        $_SESSION["Module"]["Checkbox"]["Active"] = new $_SESSION["Module"]["Checkbox"]["Type"];//Checkbox-Objekt initialisieren 
        $_SESSION["Module"]["Names"]["Active"] = new $_SESSION["Module"]["Names"]["Type"];   //Well-Benennungsobjekt initialisieren
    }
    
/*Module laden*/    
function load_module($par_type,$par_wert=FALSE,$par_create=FALSE)//$_SESSION["Module"][$par_type]["Type"], Neue Klasse, [Neues Objekt erzeugen]
         {
              foreach($_SESSION["Module"] as $key => $value) //Alle Module durchgehen
              {
                  if($_SESSION["Module"][$key]["Type"] == $par_type)          //Welches Modul soll gendert werden?
                      {
                          if(!empty($par_wert)) //Wenn ein Wert angegeben ist, neue Klasse laden, ansonsten nur einen ::firststart()-Aufruf der alten Klasse(Reboot) 
                              {
                                  if(class_exists($_SESSION["Module"][$key]["Type"])) {$_SESSION["Module"][$key]["Type"]::unload();}            //Alte Klasse lschen
                                  $_SESSION["Module"][$key]["Type"] = $par_wert;                                                                //Neue Klasse speichern 
                              }                                                             
                          if(class_exists($_SESSION["Module"][$key]["Type"])) {$_SESSION["Module"][$key]["Type"]::firststart();}  //Neue Klasse Initialisieren
                          if(!empty($par_create) && class_exists($_SESSION["Module"][$key]["Type"]))          //Wenn gewnscht: Objekt aus neuer Klasse erstellen
                              {  
                                  $_SESSION["Module"][$key]["Active"] = new $_SESSION["Module"][$key]["Type"];
                              }  
                      }
              }
         } 
/*Module vorhanden?*/    
function requirement($par_type,$par_module,$par_silent = FALSE)//$_SESSION["Module"][$par_type]["Type"], Neue Klasse, [Keinen Fehler ausgeben]
         {
            //Prfen, ob gewnschte Klasse vorhanden ist
            if(class_exists($par_module) === TRUE)
                {
                    load_module($_SESSION["Module"][$par_type]["Type"],$par_module,TRUE);  // Dann Klasse laden
                    return TRUE; //Beenden
                }
            //Ansonsten...
            //Wenn das genderte Objekt ein Settings-Klasse sein sollte: Standartfehlerklasse anzeigen
            if(stristr($par_type,"settings") === TRUE)
                {
                    load_module($_SESSION["Module"]["Settings"]["Type"],MAIN_NOANALYSIS_SE,TRUE);
                    return FALSE;
                }
            //Ansonsten Programm mit Fehler abbrechen (auer Silent-Mode ist aktiv)
            else if($par_silent !== TRUE) 
                {
                    $_SESSION["Main"]["Show"] = MAIN_MODE_ERROR;
                    $_SESSION["Main"]["Error"] = MAIN_REQUIREMENT_ERROR."[".$par_module."]";
                    return FALSE;
                }
         } 
?>



