<?php
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

//Stellt die Funktionen zur Selektion/Deselektion von Wells zur Verfgung
class cl_checkbox_default
{
        //The menu texts are defined as constants, so that an adjustment in other language is fast possible
        const TEXT_SELECT_ALL = "Select all";
        const TEXT_SELECT_NONE = "Select nothing"; 
        const TEXT_SMALLER = "smaller";
        const TEXT_BIGGER = "larger";
        const TEXT_WELLS = "Wells; per line";
        const TEXT_UP_LEFT = "A";
        const TEXT_UP_RIGHT = "B";
        const TEXT_DOWN_LEFT = "C";
        const TEXT_DOWN_RIGHT = "D";
        const TEXT_AREA_SELECT = "Select area"; 
        const TEXT_AREA_DESELECT = "Deselect area";
        //Default values settings for parameters
        const FLOAT_SSE = "0.01";
        const TEXT_7300_DELTA = "7300-Delta.csv";

        //WICHTIG: In jeder Checkbox-Klasse ntig (Wird von main beim ersten Start des Programms aufgerufen)
        public static function firststart()
             {
                  /*Initialisierung der vom Objekt eingefhrten $SESSION-Variablen*/ 
                  $_SESSION["Cl_Checkbox_Default"]["Select_SSE_Field"] = self::FLOAT_SSE;
                  $_SESSION["Cl_Checkbox_Default"]["Up_Left"] = 1;
                  $_SESSION["Cl_Checkbox_Default"]["Up_Right"] = $_SESSION["Plate_Facts"]["Rows"];
                  $_SESSION["Cl_Checkbox_Default"]["Down_Left"] = $_SESSION["Plate_Facts"]["Area"]-$_SESSION["Plate_Facts"]["Rows"];
                  $_SESSION["Cl_Checkbox_Default"]["Down_Right"] = $_SESSION["Plate_Facts"]["Area"];
             } 
             
        //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim wechsel auf ein anderes Modul aufgerufen)
        public static function unload()
             {
                  /*Lschen der vom Objekt eingefhrten $SESSION-Variablen*/ 
                  unset($_SESSION["Cl_Checkbox_Default"]); 
             } 
         
        //WICHTIG: In jeder Checkbox-Klasse ntig (Wird von main beim Aktualisieren der Anzeige aufgerufen)       
        public function show_menu()
            {
                  echo("    <div class=\"css_checkbox_default\">\n");
                  echo("        <input class=\"css_checkbox_default_button_1\" name=\"Cl_Checkbox_Default[Select_All]\" type=\"submit\" value=\"".self::TEXT_SELECT_ALL."\">\n");
                  echo("        <input class=\"css_checkbox_default_button_2\" name=\"Cl_Checkbox_Default[Select_None]\" type=\"submit\" value=\"".self::TEXT_SELECT_NONE."\">\n");
                  //Wells nach Gteparameter des Auswertungsmodul selektieren (Normalerweise Name des Parameter [1]). Es wird einfach der ["Results"][1]["ID"]-Wert des ersten Wells benutzt) 
                  echo("        <p class=\"css_checkbox_default_title\">".$_SESSION["Plate_Data"][1]["Results"][1]["ID"]."</p>\n");   
                  echo("        <input class=\"css_checkbox_default_button_3\" name=\"Cl_Checkbox_Default[Select_SSE]\" type=\"submit\" value=\"".self::TEXT_SMALLER."\">\n"); 
                  echo("        <input class=\"css_checkbox_default_field\"name=\"Cl_Checkbox_Default[Select_SSE_Field]\" type=\"text\" maxlength=\"8\" value=\"".$_SESSION["Cl_Checkbox_Default"]["Select_SSE_Field"]."\">\n");
                  echo("        <input class=\"css_checkbox_default_button_4\" name=\"Cl_Checkbox_Default[Select_SSE]\" type=\"submit\" value=\"".self::TEXT_BIGGER."\">\n");
                  echo("        <div class=\"css_checkbox_default_area\">\n");
                  echo("            <p class=\"css_checkbox_default_u_l\">".self::TEXT_UP_LEFT."</p><input class=\"css_checkbox_default_field_u_l\"name=\"Cl_Checkbox_Default[Up_Left]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Cl_Checkbox_Default"]["Up_Left"]."\">\n"); 
                  echo("            <p class=\"css_checkbox_default_u_r\">".self::TEXT_UP_RIGHT."</p><input class=\"css_checkbox_default_field_u_r\"name=\"Cl_Checkbox_Default[Up_Right]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Cl_Checkbox_Default"]["Up_Right"]."\">\n"); 
                  echo("            <p class=\"css_checkbox_default_d_l\">".self::TEXT_DOWN_LEFT."</p><input class=\"css_checkbox_default_field_d_l\"name=\"Cl_Checkbox_Default[Down_Left]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Cl_Checkbox_Default"]["Down_Left"]."\">\n"); 
                  echo("            <p class=\"css_checkbox_default_d_r\">".self::TEXT_DOWN_RIGHT."</p><input class=\"css_checkbox_default_field_d_r\"name=\"Cl_Checkbox_Default[Down_Right]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Cl_Checkbox_Default"]["Down_Right"]."\">\n"); 
                  echo("        </div>\n");
                  echo("        <input class=\"css_checkbox_default_button_5\" name=\"Cl_Checkbox_Default[Select_Area]\" type=\"submit\" value=\"".self::TEXT_AREA_SELECT."\">\n"); 
                  echo("        <input class=\"css_checkbox_default_button_6\" name=\"Cl_Checkbox_Default[Deselect_Area]\" type=\"submit\" value=\"".self::TEXT_AREA_DESELECT."\">\n"); 
                  echo("    </div>\n");
            }
        //WICHTIG: In jeder Checkbox-Klasse ntig (Wird von main beim Erhalt von Formulardaten aufgerufen)   
        public function on_request()
            {
                //Selektion mit Buttons gendert-->Alle, Keine, Alle mit Daten?
                //Alle  Wells selektiert?
                if(isset($_REQUEST["Cl_Checkbox_Default"]["Select_All"])) 
                    {
                        //Alle selektieren
                        $this->process_checked(1);
                        $_SESSION["Main"]["Show"] = MAIN_MODE_ALL;
                    } 
                 //Keine Wells selektiert?
                 elseif(isset($_REQUEST["Cl_Checkbox_Default"]["Select_None"])) 
                    {
                        //Alle selektieren
                        $this->process_checked(2);
                        $_SESSION["Main"]["Show"] = MAIN_MODE_ALL;
                    } 
                 //Selektion nach SSE
                 elseif(isset($_REQUEST["Cl_Checkbox_Default"]["Select_SSE"]))
                    {
                        if(htmlentities($_REQUEST["Cl_Checkbox_Default"]["Select_SSE"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1") == self::TEXT_SMALLER){$this->process_checked(3);} //bessere Wells selektieren
                        else{$this->process_checked(4);} //bessere Wells selektieren
                        $_SESSION["Main"]["Show"] = MAIN_MODE_ALL;
                    }
                 //Selektion nach Bereich
                 elseif(isset($_REQUEST["Cl_Checkbox_Default"]["Select_Area"]))
                    {
                        $this->process_checked(5,1);
                        $_SESSION["Main"]["Show"] = MAIN_MODE_ALL;
                    }
                 //Selektion aufheben nach Bereich
                 elseif(isset($_REQUEST["Cl_Checkbox_Default"]["Deselect_Area"]))
                    {
                        $this->process_checked(6,0);
                        $_SESSION["Main"]["Show"] = MAIN_MODE_ALL;
                    }
                 //Nichts gedrckt, nur prfen, ob der User die Selektion verndert hat
                 else {$this->process_checked();}
            }
        /*Den Check-Status prozessieren*/
        private function process_checked($par_witch=0,$par_how=-1)
            {
                  
                //Platte neu geladen und kein Selektionsbutton gedrckt? Alle Datengefllte Wells = Ausgefllte Wells
                if(bc_max($_SESSION["Plate_Checkbox"],1) == -1) 
                {
                    //Aus $_SESSION["Plate_Checkbox"] wieder Array erstellen
                    $_SESSION["Plate_Checkbox"] = array(count($_SESSION["Plate_Data"]));
                    //Zwischenvariable, um Platten-Fluoreszenswerte in 0 und 1 umzusetzen
                    $zwischen=0;
                    /*Alle Wells kontrollieren*/
                    for($a=1; $a < count($_SESSION["Plate_Data"]); $a++)
                        {
                            if(count($_SESSION["Plate_Data"][$a]["Measured_Data"]) > 1){$zwischen = 1;}  //Fluoreszenswerte vorhanden?-->1
                            else{$zwischen = -1;}                                                        //Kein Wert? Kein Check-Button!-->-1
                            $_SESSION["Plate_Checkbox"][$a] = $zwischen;  
                        } 
                }
                //Ansonsten immer alle Eingaben durch den Benutzer sichern (Die REQUEST-Verarbeitung der Select-Buttons erfolgt erst anschlieend!)
                else
                {
                    $c=array();
                    if(isset($_REQUEST["Plate_Checkbox"]))   //Ist die Platte berhaupt sichtbar
                        {
                            for($i=1;$i < $_SESSION["Plate_Facts"]["Area"]+1;$i++)
                                {
                                    //Wells OHNE DATEN erzeugen keinen Request->mit -1 speichern
                                    if(!isset($_REQUEST["Plate_Checkbox"][$i]) && $_SESSION["Plate_Checkbox"][$i] < 0)
                                        {
                                            $c[$i] = -1; 
                                            continue;
                                        }
                                    //Wenn eine nderung stattgefunden hat, Checkbox-Werte speichern, die O.K. sind. 
                                    elseif(isset($_REQUEST["Plate_Checkbox"][$i])) {$_SESSION["Plate_Checkbox"][$i] = 1;}
                                    else{$_SESSION["Plate_Checkbox"][$i] = 0;}
                                }
                        }
                }
                //Wenn eine Platte existiert, immer alle Felder checken
                if(isset($_SESSION["Plate_Data"]))
                {
                    //SSE-Select-Feld
                    /*Wert der fr Eingabefelder zwischenspeichern*/
                    $zwischen = htmlentities(@$_REQUEST["Cl_Checkbox_Default"]["Select_SSE_Field"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");
                    if(!is_numeric($zwischen)){$zwischen = self::FLOAT_SSE;} //Kein gltiger SSE-Wert? Default-Wert setzen
                    $_SESSION["Cl_Checkbox_Default"]["Select_SSE_Field"] = $zwischen;
                    //Area-Select-Felder
                    /*Wert fr Auswahlfelder zwischenspeichern zwischenspeichern*/
                    $_SESSION["Cl_Checkbox_Default"]["Up_Left"] = intval(htmlentities(@$_REQUEST["Cl_Checkbox_Default"]["Up_Left"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                    $_SESSION["Cl_Checkbox_Default"]["Up_Right"] = intval(htmlentities(@$_REQUEST["Cl_Checkbox_Default"]["Up_Right"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                    $_SESSION["Cl_Checkbox_Default"]["Down_Left"] = intval(htmlentities(@$_REQUEST["Cl_Checkbox_Default"]["Down_Left"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                    $_SESSION["Cl_Checkbox_Default"]["Down_Right"] = intval(htmlentities(@$_REQUEST["Cl_Checkbox_Default"]["Down_Right"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                    //Bei Fehlschlag oder werten auerhalb des Plattenbereichs Default-Werte einsetzen
                    if($_SESSION["Cl_Checkbox_Default"]["Up_Left"] <= 0 || $_SESSION["Cl_Checkbox_Default"]["Up_Left"] >= count($_SESSION["Plate_Data"])){$_SESSION["Cl_Checkbox_Default"]["Up_Left"] = 1;} 
                    if($_SESSION["Cl_Checkbox_Default"]["Up_Right"] <= 0 || $_SESSION["Cl_Checkbox_Default"]["Up_Right"] >= count($_SESSION["Plate_Data"])){$_SESSION["Cl_Checkbox_Default"]["Up_Right"] = $_SESSION["Plate_Facts"]["Rows"];} 
                    if($_SESSION["Cl_Checkbox_Default"]["Down_Left"] <= 0 || $_SESSION["Cl_Checkbox_Default"]["Down_Left"] >= count($_SESSION["Plate_Data"])){$_SESSION["Cl_Checkbox_Default"]["Down_Left"] = $_SESSION["Plate_Facts"]["Area"]+1-$_SESSION["Plate_Facts"]["Rows"];} 
                    if($_SESSION["Cl_Checkbox_Default"]["Down_Right"] <= 0 || $_SESSION["Cl_Checkbox_Default"]["Down_Right"] >= count($_SESSION["Plate_Data"])){$_SESSION["Cl_Checkbox_Default"]["Down_Right"] = $_SESSION["Plate_Facts"]["Area"];} 
                    //Werte nach gre sortieren
                    $area = array($_SESSION["Cl_Checkbox_Default"]["Up_Left"],$_SESSION["Cl_Checkbox_Default"]["Up_Right"],$_SESSION["Cl_Checkbox_Default"]["Down_Left"],$_SESSION["Cl_Checkbox_Default"]["Down_Right"]);
                    sort($area,SORT_NUMERIC);
                    /*Die Zusammenstellung des sortierten Arrays speichern*/
                    $_SESSION["Cl_Checkbox_Default"]["Up_Left"] = $area[0];
                    $_SESSION["Cl_Checkbox_Default"]["Up_Right"] = $area[1];
                    $_SESSION["Cl_Checkbox_Default"]["Down_Left"] = $area[2];
                    $_SESSION["Cl_Checkbox_Default"]["Down_Right"] = $area[3];
                }
                //Alle selektieren? 
                if($par_witch == 1) 
                {
                    /*Alle Wells auf 1 setzen*/
                    for($a=1; $a < count($_SESSION["Plate_Data"]); $a++)
                        {
                            if($_SESSION["Plate_Checkbox"][$a] != -1) {$_SESSION["Plate_Checkbox"][$a] = 1;}  //Nur Wells Checken, die Checkbutton haben drfen
                        } 
                    
                }
                //Nichts selektieren? 
                if($par_witch == 2) 
                {
                    /*Alle Wells auf 0 setzen*/
                    for($a=1; $a < count($_SESSION["Plate_Data"]); $a++)
                        {
                            if($_SESSION["Plate_Checkbox"][$a] != -1) {$_SESSION["Plate_Checkbox"][$a] = 0;}  //Nur Wells Unchecken, die Checkbutton haben drfen
                        } 
                }
                //Selektion nach SSE? 
                if($par_witch == 3 || $par_witch == 4)  //3 = kleiner SSE selektieren; 4 = grere SSE selektieren
                { 
                    /*Alle Wells auf 0 setzen*/
                    for($a=1; $a < count($_SESSION["Plate_Data"]); $a++)
                        {
                            if($_SESSION["Plate_Checkbox"][$a] == -1) {continue;}  //Well ohne Checkbutton? Auch keinen setzen! 
                            //Well-Ergebniss ist keine Zahl? Vergleich sparen, gilt als maximaler Wert (=niedrigste Przision)(Alle Ergebnisse, die Text enthalten, sind ungltige Ergebnisse!)
                            if(!is_numeric($_SESSION["Plate_Data"][$a]["Results"][1]["Value"]))
                                {
                                    if($par_witch == 3) {$_SESSION["Plate_Checkbox"][$a] = 0;} //SSE kleiner als...(3)--> unchecken 
                                    else {$_SESSION["Plate_Checkbox"][$a] = 1;}                //SSE grer als...(4)--> selektieren 
                                    continue;
                                }  
                            //SSE kleiner als... selektieren (3)
                            if(bc_comp($zwischen,$_SESSION["Plate_Data"][$a]["Results"][1]["Value"]) <= 0 && $par_witch == 3) {$_SESSION["Plate_Checkbox"][$a] = 0;}  //SSE grer? Well unchecken!
                            elseif($par_witch == 3) {$_SESSION["Plate_Checkbox"][$a] = 1;}  //Ansonsten selektieren
                            //SSE kleiner als... selektieren (4)
                            if(bc_comp($zwischen,$_SESSION["Plate_Data"][$a]["Results"][1]["Value"]) > 0 && $par_witch == 4) {$_SESSION["Plate_Checkbox"][$a] = 0;}  //SSE kleiner? Well unchecken!
                            elseif($par_witch == 4) {$_SESSION["Plate_Checkbox"][$a] = 1;}  //Ansonsten selektieren
                        } 
                }
                //Selektion von Flche auf Platte (A(X|Y)) B(X|Y) C(X|Y) D(X|Y)
                if($par_witch == 5 ||$par_witch ==6)  
                {         
                    //Sonderfall: Zeilenweise ausgewhlt
                    if(($area[0] == $area[1] && $area[2] == $area[3])||($area[1] == $area[2] && $area[2] == $area[3])||($area[0] == $area[1] && $area[1] == $area[2]))
                        {
                            for($x=$area[0]; $x <= $area[3]; $x++)
                                {
                                    if($_SESSION["Plate_Checkbox"][$x] == -1) {continue;}
                                    $_SESSION["Plate_Checkbox"][$x] = $par_how;
                                }
                            return;
                        }          
                    //In welcher Zeile liegen die Werte?
                    $row_a = div_int_up($area[0],$_SESSION["Plate_Facts"]["Rows"])-1;    
                    $row_b = div_int_up($area[1],$_SESSION["Plate_Facts"]["Rows"])-1; 
                    $row_c = div_int_up($area[2],$_SESSION["Plate_Facts"]["Rows"])-1;    
                    $row_d = div_int_up($area[3],$_SESSION["Plate_Facts"]["Rows"])-1;  
                    $line_div_a_c = $area[2]-($area[0]+($row_c-$row_a)*$_SESSION["Plate_Facts"]["Rows"]);  //Welchen Abstand htten A und C, wenn sie in der selben Reihe liegen wrden?
                    $line_div_b_d = $area[3]-($area[1]+($row_d-$row_b)*$_SESSION["Plate_Facts"]["Rows"]);  //Welchen Abstand htten B und D, wenn sie in der selben Reihe liegen wrden? 
                    //Start-Zeile ist Zeile 0
                    $line = 0;
                    $actual_a = $area[0];
                    $actual_b = $area[1];
                    /*Wells selektieren*/
                    for($i=1; $i <= $_SESSION["Plate_Facts"]["Area"]; $i++)
                        {
                            if($_SESSION["Plate_Checkbox"][$i] == -1) {continue;}  //Well ohne Checkbutton? Auch keinen setzen! 
                            $line = ceil($i/$_SESSION["Plate_Facts"]["Rows"])-1; //Nach dem Erreichen der letzten Spalte wieder eine Line hochzhlen
                            if($line>$row_a) {$actual_a = $area[0] + $_SESSION["Plate_Facts"]["Rows"]*($line-$row_a);}
                            if($line>$row_b) {$actual_b = $area[1] + $_SESSION["Plate_Facts"]["Rows"]*($line-$row_b);}
                            //Den Verlaufsbereich zwischen AC und BD ermitteln (schrge Viereckkanten)
                            $test_ac = $actual_a;
                            $test_bd = $actual_b;
                            if($row_c!=0){$test_ac = $actual_a+ round($line_div_a_c*($line/($row_c)));}
                            if($row_d!=0){$test_bd = $actual_b+ round($line_div_b_d*($line/($row_d)));}
                            //Wenn das Well der Aktuellen Zeile im Wertebereich liegt: Checken oder Unchecken (je nach Button
                            if($i>=$test_ac && $i<=$test_bd && $i>=$area[0] && $i<=$area[3]){$_SESSION["Plate_Checkbox"][$i] = $par_how;}
                        }
                }
            }
}
?>

