<?php
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

/*Importfunktion zum Copy- & Paste-Fllen der Wells*/
class cl_import_default
{
     //The menu texts are defined as constants, so that an adjustment in other language is fast possible
            const TEXT_IMPORT = "Import file";
            const TEXT_SEPARATOR = "Decimal separator:";
            const TEXT_HINT = "Important: Please attend the decimal separator (By default point; in Europe = comma).";  
            const TEXT_WELL = "Well&nbsp";
            const TEXT_NAME = "&nbsp&nbsp&nbspName:&nbsp";
            const TEXT_DETECTOR = "&nbsp&nbsp&nbspDetector:&nbsp";
            private $Well; //Variable mit Wellnummer zur besseren Code-Lesbarkeit

    //WICHTIG: In jeder Import-Klasse ntig (Wird von main beim ersten Start des Programms aufgerufen)
    public static function firststart()
         {
              /*Initialisierung der vom Objekt eingefhrten $SESSION-Variablen*/ 
              $_SESSION["Cl_Import_Default"]["Separator"] = "."; 
         } 
    //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim wechsel auf ein anderes Modul aufgerufen)
    public static function unload()
         {
              /*Lschen der vom Objekt eingefhrten $SESSION-Variablen*/ 
              unset($_SESSION["Cl_Import_Default"]); 
         } 
         
    //WICHTIG: In jeder Import-Klasse ntig (Wird von main beim Aktualisieren der Anzeige aufgerufen)      
    public function show_menu()
         {
          echo("    <div class=\"css_import_default\">\n");
          echo("        <p class=\"css_import_default_title\">".self::TEXT_WELL.$this->Well.self::TEXT_NAME.$_SESSION["Plate_Data"][$this->Well]["Name"]["Well"].self::TEXT_DETECTOR.$_SESSION["Plate_Data"][$this->Well]["Name"]["Detector"]."</p>\n"); //Well-Nr, Detektor
          echo("        <textarea class=\"css_import_default_field_1\" name=\"Cl_Import_Default[Import_Field]\" cols=\"5\" rows=\"1\">\n"); 
          //Bereits vorhandene Daten im Well? einlesen
          for($i=0;$i<count($_SESSION["Plate_Data"][$this->Well]["Measured_Data"]);$i++)
              {
                  echo($_SESSION["Plate_Data"][$this->Well]["Measured_Data"][$i].chr(10)); //Werte untereinander schreiben
              }
          echo("        </textarea>\n");
          echo("        <p class=\"css_import_default_text_2\">".self::TEXT_SEPARATOR."</p>\n");
          echo("        <input type=\"text\" name=\"Cl_Import_Default[Separator]\" class=\"css_import_default_field_2\" maxlength=\"1\" value=\"".$_SESSION["Cl_Import_Default"]["Separator"]."\">\n");
          echo("        <p class=\"css_import_default_text_1\">".self::TEXT_HINT."</p>\n"); 
          echo("        <input class=\"css_import_default_button\" name=\"Cl_Import_Default[Import]\" type=\"submit\" value=\"".self::TEXT_IMPORT."\">\n"); 
          echo("    </div>\n");
        }
    //WICHTIG: In jeder Import-Klasse ntig (Wird von main beim Erhalt von Formulardaten aufgerufen)   
    public function on_request()
      {
          
          //Daten importieren?
          if(isset($_REQUEST["Plate_Well_Button"])) 
              {
                  $grenze = count($_SESSION["Plate_Data"]);
                  //Alle Buttons durchgehen, um Nummer zu finden
                  for($i=1;$i<$grenze;$i++)
                  {
                      if(isset($_REQUEST["Plate_Well_Button"][$i])) 
                          {
                              $_SESSION["Cl_Import_Default"]["Well_Button"] = $i;
                              $this->Well = $i; //Krzere objektinterne Variable mit Wellnummer zur besseren Code-Lesbarkeit
                              //Anzeige steuern (Nur Importmen anzeigen)
                              $_SESSION["Main"]["Show"] = $_SESSION["Module"]["Import"]["Type"];  
                              break; 
                          }
                  }
              }
           if(isset($_REQUEST["Cl_Import_Default"]["Import"])) 
              {
                  $this->Well = $_SESSION["Cl_Import_Default"]["Well_Button"]; //Krzere objektinterne Variable mit Wellnummer zur besseren Code-Lesbarkeit
                  $this->import_data();
                  $_SESSION["Main"]["Show"]  = MAIN_MODE_ALL; //Nach dem Import-Vorgang Platte aktualisieren
              }
      }  
    /*Daten importieren*/  
    private function import_data()
        {
            //Trennzeichen, die ersetzt werden. Chr(9) = Tab; chr(10) = Zeilenumbruch; chr(32) = Leerzeichen.
            //$replace_first=array(";","|",chr(9),chr(10),",","<br>","</br>","&nbsp");
            //Nur Verarbeiten, wenn String bergeben wird
            if(!isset($_REQUEST["Cl_Import_Default"]["Import_Field"])){return;}
            //Speichern, welches Zeichen zum Trennen der Dezimalstellen benutzt wird (Standartmig Komma)
            if(isset($_REQUEST["Cl_Import_Default"]["Separator"])) {$_SESSION["Cl_Import_Default"]["Separator"] = htmlentities($_REQUEST["Cl_Import_Default"]["Separator"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");}
            else{$_SESSION["Cl_Import_Default"]["Separator"] = ".";}
            //Text sichern & und nicht zugelassene Zeichen durch Leerzeichen ersetzen (Zugelassen:+,-,$_SESSION["Cl_Import_Default"]["Separator"],0-9,Ee)
            $text = preg_replace("/[^\+\-0-9eE\\".$_SESSION["Cl_Import_Default"]["Separator"]."]/"," ",$_REQUEST["Cl_Import_Default"]["Import_Field"]);
            $textnew = preg_replace("/((\-?+[0-9]{1,})(\\".$_SESSION["Cl_Import_Default"]["Separator"]."{1}([0-9]{1,}))?([Ee]((\-?)([0-9]{1,3})))?)/","sep\\1sep",$text); //Zahlen extrahieren, auch E oder e als scientific-notation interpretieren
            $textnew = str_replace($_SESSION["Cl_Import_Default"]["Separator"],".",$textnew);   //Egal welcher Seperator gewhlt wurde, am Ende steht wieder ein Punkt
            //$textnew = preg_filter("/ (\-|\+|[0-9])/",":\\1",$text);   Alle Leerzeichenin Kombination mit +,- oder Zahl(= Anfang Wert) durch : ersetzen
            $searched = explode("sep",$textnew);
            //$_SESSION["Plate_Data"] des Wells lschen, damit sich bei krzeren Eingaben nicht neue mit alten Werten mischen
            $_SESSION["Plate_Data"][$this->Well][1] = array(0);
            //Wenn keine Zahl brig bleibt! direkt lschen!
            if(count($searched) < 1) return;
            //Zahlen in Session-Array schreiben
            //Die in Array geschriebenen Strings in Zahlen konvertieren
            $sorted = array(); 
            $count = 0;   //Zhlvariable fr neuen String, damit keine Lcken entstehen
            for($a=1;$a<count($searched)-1;$a+=2)//eins weiter zhlen, da nur jeder 2. String benutzt werden soll
                {   
                    $sorted[$count] = bc_parformat($searched[$a]);
                    $count++;
                }
            $_SESSION["Plate_Data"][$this->Well]["Measured_Data"] = $sorted; //Eingelesene Werte speichern
            if(count($_SESSION["Plate_Data"][$this->Well]["Measured_Data"]) > 0) 
            {
              $_SESSION["Plate_Checkbox"][$this->Well]= 1;
            } //bisher leeres Well mit neue Daten? Checkbox erstellen!
        } 
}  
?>

