<?php
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

//Stellt die Funktionen zur nderung von Wellnamen und Detektoren bereit
class cl_names_default
{
        //Die Mentexte werden als Konstanten definiert, damit eine Sprachanpassung schnell mglich ist
        const TEXT_NEW_NAME = "New name";
        const TEXT_NEW_DETECTOR = "New detector"; 
        const TEXT_OR = "or";
        const TEXT_OLD_NAME = "Choose name";
        const TEXT_OLD_DETECTOR = "Choose detector";
        const TEXT_CHANGE_NAME = "Change name(s)";
        const TEXT_ADD_NAME = "Add name";
        const TEXT_CHANGE_DETECTOR = "Change detector for selected wells";

        //WICHTIG: In jeder Checkbox-Klasse ntig (Wird von main beim ersten Start des Programms aufgerufen)
        public static function firststart()
             {
                  /*Initialisierung der vom Objekt eingefhrten $SESSION-Variablen*/ 
                  $_SESSION["Cl_Names_Default"]["New_Name"] = "";
                  $_SESSION["Cl_Names_Default"]["Old_Name"] = "";
                  $_SESSION["Cl_Names_Default"]["New_Detector"] = "";
                  $_SESSION["Cl_Names_Default"]["Old_Detector"] = "";
             } 
             
        //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim wechsel auf ein anderes Modul aufgerufen)
        public static function unload()
             {
                  /*Lschen der vom Objekt eingefhrten $SESSION-Variablen*/ 
                  unset($_SESSION["Cl_Checkbox_Default"]); 
             } 
        //WICHTIG: In jeder Checkbox-Klasse ntig (Wird von main beim Aktualisieren der Anzeige aufgerufen)       
        public function show_menu()
            {
                echo("    <div class=\"cl_names_default_menu\">\n");
                echo("        <input class=\"cl_names_default_field_1\"name=\"Cl_Names_Default[New_Name]\" type=\"text\" maxlength=\"32\" value=\"".self::TEXT_NEW_NAME."\">\n");
                echo("        <p class=\"cl_names_default_text_1\">".self::TEXT_OR."</p>");
                echo("        <select name=\"Cl_Names_Default[Old_Name]\" class=\"cl_names_default_select_1\" size=\"1\">\n");
                echo("                <option value=\"".self::TEXT_OLD_NAME."\">".self::TEXT_OLD_NAME."</option>\n"); //Erster Eintrag: Name whlen
                for($i=0; $i<count($_SESSION["Plate_Wellnames"]); $i++)
                    {
                              echo("                <option value=\"".$_SESSION["Plate_Wellnames"][$i]."\">".$_SESSION["Plate_Wellnames"][$i]."</option>\n");    
                    }  
                echo("        </select>\n");  
                echo("        <input class=\"cl_names_default_button_1\" name=\"Cl_Names_Default[Change_Name]\" type=\"submit\" value=\"".self::TEXT_CHANGE_NAME."\">\n");
                echo("        <input class=\"cl_names_default_button_1_1\" name=\"Cl_Names_Default[Add_Name]\" type=\"submit\" value=\"".self::TEXT_ADD_NAME."\">\n");
                echo("        <div class=\"cl_names_default_detector\">\n");
                echo("            <input class=\"cl_names_default_field_2\"name=\"Cl_Names_Default[New_Detector]\" type=\"text\" maxlength=\"32\" value=\"".self::TEXT_NEW_DETECTOR."\">\n");
                echo("            <p class=\"cl_names_default_text_2\">".self::TEXT_OR."</p>");
                echo("            <select name=\"Cl_Names_Default[Old_Detector]\" class=\"cl_names_default_select_2\" size=\"1\">\n");
                echo("                <option value=\"".self::TEXT_OLD_DETECTOR."\">".self::TEXT_OLD_DETECTOR."</option>\n"); //Erster Eintrag: Detektor whlen
                for($i=0; $i<count($_SESSION["Plate_Detectors"]); $i++)
                    {
                              echo("                    <option style=\"background-color:".$_SESSION["Plate_Detectors"][$i]["Color"]."\" value=\"".$_SESSION["Plate_Detectors"][$i]["Detector"]."\">".$_SESSION["Plate_Detectors"][$i]["Detector"]."</option>\n");    
                    }  
                echo("            </select>\n");  
                echo("            <input class=\"cl_names_default_button_2\" name=\"Cl_Names_Default[Change_Detector]\" type=\"submit\" value=\"".self::TEXT_CHANGE_DETECTOR."\">\n");
                echo("        </div>\n");
                echo("    </div>\n");
            }
        //WICHTIG: In jeder Import-Klasse ntig (Wird von main beim Erhalt von Formulardaten aufgerufen)   
        public function on_request()
          {
              //Namen ndern
              if(isset($_REQUEST["Cl_Names_Default"]["Change_Name"])) 
                  {
                      $_SESSION["Cl_Names_Default"]["New_Name"] = preg_replace("/[^\+\-0-9aA-zZ\_\s]/","",html_entity_decode($_REQUEST["Cl_Names_Default"]["New_Name"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1")); //Sonderzeichen aus Eingabefeld entfernen
                      $_SESSION["Cl_Names_Default"]["New_Name"] = trim(preg_replace("/\s{1,}/"," ",$_SESSION["Cl_Names_Default"]["New_Name"])); //Leerzeichen aus Eingabefeld entfernen (vorne darf eins stehen bleiben)
                      $_SESSION["Cl_Names_Default"]["Old_Name"] = preg_replace("/[^\+\-0-9aA-zZ\_\s]/","",html_entity_decode($_REQUEST["Cl_Names_Default"]["Old_Name"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                      $_SESSION["Cl_Names_Default"]["Old_Name"] = trim(preg_replace("/\s{1,}/"," ",$_SESSION["Cl_Names_Default"]["Old_Name"])); //Leerzeichen aus Eingabefeld entfernen (vorne darf eins stehen bleiben)
                      if($_SESSION["Cl_Names_Default"]["New_Name"] != self::TEXT_NEW_NAME && strlen($_SESSION["Cl_Names_Default"]["New_Name"])>0)
                          {
                              $this->newname();
                          }
                      elseif($_SESSION["Cl_Names_Default"]["Old_Name"] !=  self::TEXT_OLD_NAME)
                          {
                              $this->oldname();
                          }
                      $_SESSION["Main"]["Show"] = MAIN_MODE_ALL;
                  }
              //Namen an vorhandenen anhngen
              if(isset($_REQUEST["Cl_Names_Default"]["Add_Name"])) 
                  {
                      $_SESSION["Cl_Names_Default"]["New_Name"] = preg_replace("/[^\+\-0-9aA-zZ\_\s]/","",html_entity_decode($_REQUEST["Cl_Names_Default"]["New_Name"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1")); //Sonderzeichen aus Eingabefeld entfernen
                      $_SESSION["Cl_Names_Default"]["New_Name"] = trim(preg_replace("/\s{1,}/"," ",$_SESSION["Cl_Names_Default"]["New_Name"])); //Leerzeichen aus Eingabefeld entfernen (vorne darf eins stehen bleiben)
                      $_SESSION["Cl_Names_Default"]["Old_Name"] = preg_replace("/[^\+\-0-9aA-zZ\_\s]/","",html_entity_decode($_REQUEST["Cl_Names_Default"]["Old_Name"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                      $_SESSION["Cl_Names_Default"]["Old_Name"] = trim(preg_replace("/\s{1,}/"," ",$_SESSION["Cl_Names_Default"]["Old_Name"])); //Leerzeichen aus Eingabefeld entfernen (vorne darf eins stehen bleiben)
                      if($_SESSION["Cl_Names_Default"]["New_Name"] != self::TEXT_NEW_NAME && strlen($_SESSION["Cl_Names_Default"]["New_Name"])>0)
                          {
                              $this->addnewname();
                          }
                      elseif($_SESSION["Cl_Names_Default"]["Old_Name"] !=  self::TEXT_OLD_NAME)
                          {
                              $this->addoldname();
                          }
                      $_SESSION["Main"]["Show"] = MAIN_MODE_ALL;
                  }
               //Detektor ndern
              if(isset($_REQUEST["Cl_Names_Default"]["Change_Detector"])) 
                  {
                      $_SESSION["Cl_Names_Default"]["New_Detector"] = preg_replace("/[^\+\-0-9aA-zZ\_\s]/","",html_entity_decode($_REQUEST["Cl_Names_Default"]["New_Detector"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1")); //Sonderzeichen aus Eingabefeld entfernen
                      $_SESSION["Cl_Names_Default"]["New_Detector"] = trim(preg_replace("/\s{1,}/"," ",$_SESSION["Cl_Names_Default"]["New_Detector"])); //Leerzeichen aus Eingabefeld entfernen
                      $_SESSION["Cl_Names_Default"]["Old_Detector"] = preg_replace("/[^\+\-0-9aA-zZ\_\s]/","",html_entity_decode($_REQUEST["Cl_Names_Default"]["Old_Detector"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                      $_SESSION["Cl_Names_Default"]["Old_Detector"] = trim(preg_replace("/\s{1,}/"," ",$_SESSION["Cl_Names_Default"]["Old_Detector"])); //Leerzeichen aus Eingabefeld entfernen
                      if($_SESSION["Cl_Names_Default"]["New_Detector"] != self::TEXT_NEW_DETECTOR && strlen($_SESSION["Cl_Names_Default"]["New_Detector"])>0)
                          {
                              $this->newdetector();
                          }
                      elseif($_SESSION["Cl_Names_Default"]["Old_Detector"] != self::TEXT_OLD_DETECTOR)
                          {
                              $this->olddetector();
                          }
                      $_SESSION["Main"]["Show"] = MAIN_MODE_ALL;
                  }
               //Am Schluss:Namensliste alphabetisch sortieren
               sort($_SESSION["Plate_Wellnames"]);
          }
          
          
        //Neu eingegebenen Namen zuweisen
        private function newname()
          {
                for($i=0; $i<count($_SESSION["Plate_Wellnames"]); $i++)
                    {
                        if($_SESSION["Plate_Wellnames"][$i] == $_SESSION["Cl_Names_Default"]["New_Name"]) 
                            {
                                $i = -1;
                                break; 
                            }
                    }
                if($i != -1){$_SESSION["Plate_Wellnames"][$i] = $_SESSION["Cl_Names_Default"]["New_Name"];} //Name schon in Liste? nicht neu einspeichern!
                for($a=1;$a<count($_SESSION["Plate_Checkbox"]); $a++) 
                    {
                        if($_SESSION["Plate_Checkbox"][$a] == 1){$_SESSION["Plate_Data"][$a]["Name"]["Well"] = $_SESSION["Cl_Names_Default"]["New_Name"];} //Allen selektierten Wells neuen Namen zuweisen
                    }  
          } 
        //Aus Liste gewhlten Namen zuweisen
        private function oldname()
          {
                for($a=1;$a<count($_SESSION["Plate_Checkbox"]); $a++) 
                    {
                        if($_SESSION["Plate_Checkbox"][$a] == 1){$_SESSION["Plate_Data"][$a]["Name"]["Well"] = $_SESSION["Cl_Names_Default"]["Old_Name"];} //Allen selektierten Wells neuen Namen zuweisen
                    }  
          }
        //Neu eingegebenen Namen zuweisen
        private function addnewname()
          {
                for($i=0; $i<count($_SESSION["Plate_Wellnames"]); $i++)
                    {
                        if($_SESSION["Plate_Wellnames"][$i] == $_SESSION["Cl_Names_Default"]["New_Name"]) 
                            {
                                $i = -1;
                                break; 
                            }
                    }
                if($i != -1){$_SESSION["Plate_Wellnames"][$i] = $_SESSION["Cl_Names_Default"]["New_Name"];} //Name schon in Liste? nicht neu einspeichern!
                for($a=1;$a<count($_SESSION["Plate_Checkbox"]); $a++) 
                    {
                        if($_SESSION["Plate_Checkbox"][$a] == 1){$_SESSION["Plate_Data"][$a]["Name"]["Well"] = $_SESSION["Plate_Data"][$a]["Name"]["Well"].$_SESSION["Cl_Names_Default"]["New_Name"];} //Allen selektierten Wells neuen Namen zuweisen
                    }  
          } 
        //Aus Liste gewhlten Namen zuweisen
        private function addoldname()
          {
                for($a=1;$a<count($_SESSION["Plate_Checkbox"]); $a++) 
                    {
                        if($_SESSION["Plate_Checkbox"][$a] == 1){$_SESSION["Plate_Data"][$a]["Name"]["Well"] = $_SESSION["Plate_Data"][$a]["Name"]["Well"].$_SESSION["Cl_Names_Default"]["Old_Name"];} //Allen selektierten Wells neuen Namen zuweisen
                    }  
          }
        //Neu eingegebenen Detektor zuweisen
        private function newdetector()
          {
                for($i=0; $i<count($_SESSION["Plate_Detectors"]); $i++)
                    {
                        if($_SESSION["Plate_Detectors"][$i]["Detector"] == $_SESSION["Cl_Names_Default"]["New_Detector"]) 
                            {
                                $i = -1;
                                break; 
                            }
                    }
                if($i != -1){$_SESSION["Plate_Detectors"][$i] = array("Detector"=>$_SESSION["Cl_Names_Default"]["New_Detector"],"Color"=>NULL);} //Detektor schon in Liste? nicht neu einspeichern!
                for($a=1;$a<count($_SESSION["Plate_Checkbox"]); $a++) 
                    {
                        if($_SESSION["Plate_Checkbox"][$a] == 1){$_SESSION["Plate_Data"][$a]["Name"]["Detector"] = $_SESSION["Cl_Names_Default"]["New_Detector"];} //Allen selektierten Wells neuen Detektor zuweisen
                    }  
          } 
        //Aus Liste gewhlten Detektor zuweisen
        private function olddetector()
          {
                for($a=1;$a<count($_SESSION["Plate_Checkbox"]); $a++) 
                    {
                        if($_SESSION["Plate_Checkbox"][$a] == 1){$_SESSION["Plate_Data"][$a]["Name"]["Detector"] = $_SESSION["Cl_Names_Default"]["Old_Detector"];} //Allen selektierten Wells neuen Detektor zuweisen
                    } 
          }      
}
?>

