<?php
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

/*Stellt die Exportfunktion zur Verfgung*/
class cl_save_default
{
    //The menu texts are defined as constants, so that an adjustment in other language is fast possible
    const TEXT_NAME = "Name: ";
    const TEXT_NAME_DEFAULT = "New plate";
    const TEXT_SAVE = "Save:";
    const TEXT_SELECTED = "Selection"; 
    const TEXT_ALL = "All";
    const TEXT_DECIMAL = "Decimal...";
    const TEXT_POINT = "Point";
    const TEXT_COMMA = "Comma";
    const TEXT_EXPORT = "Export";
    const TEXT_LINK_1 = "CSV-file download </br>(";
    const TEXT_LINK_2 = ". update)";
    const TEXT_SAVE_NR = "Well-no.";
    const TEXT_SAVE_WELL = "Well-name";
    const TEXT_SAVE_DETECTOR = "Detector";
    const TEXT_SAVE_DATA = "Measured value cycle";
    const TEXT_SAVE_DATA_COMPUTED = "Model value cycle";
    const TEXT_SAVE_NO_RESULTS_VALUE = "n.a.";
    const TEXT_SAVE_NO_DATA_VALUE = "";
    const TEXT_SAVE_NO_MODEL_VALUE = "";
    //Headings of the foot file, are required to file to load later
    const FOOT_PROGRAMM = "Application";
    const FOOT_MAJOR = "Version";
    const FOOT_MINOR = "Minor version";
    const FOOT_PATCH = "Patch level";
    const FOOT_MODULE_SAVE = "Save module";
    const FOOT_MODULE_ANALYSIS = "Analysis module";
    const FOOT_RESULT_PAR = "Result parameters";
    const FOOT_PLATE = "Plate size";
    
    //Pfad zum Serververzeichnis, in dem erstellte CSV-Dateien gespeichert werden
    const DIR_EXPORT = "exported/";
    
    //WICHTIG: In jeder Save-Klasse ntig (Wird von main beim ersten Start des Programms aufgerufen)
    public static function firststart()
         {
              /*Initialisierung der vom Objekt eingefhrten $SESSION-Variablen*/ 
              $_SESSION["Cl_Save_Default"]["Actual"] = 0;     //Zhler, wie viele Aktualisierungen durchgefhrt wurden
              $_SESSION["Cl_Save_Default"]["Decimal"][1] = "";    //Radiobutton: Komma oder Punkt als Dezimaltrennzeichen
              $_SESSION["Cl_Save_Default"]["Decimal"][2] = "checked=\"checked\"";    
              $_SESSION["Cl_Save_Default"]["Decimal"]["Char"] = ",";    
              $_SESSION["Cl_Save_Default"]["Skip_Empty"][1] = "";    //Standart: alles Speichern aktivieren
              $_SESSION["Cl_Save_Default"]["Skip_Empty"][2] = "checked=\"checked\"";                    
         } 
         
    //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim wechsel auf ein anderes Modul aufgerufen)
    public static function unload()
         {
              /*Lschen der vom Objekt eingefhrten $SESSION-Variablen*/ 
              unset($_SESSION["Cl_Save_Default"]); 
         } 
         
    //WICHTIG: In jeder Save-Klasse ntig (Wird von main beim Aktualisieren der Anzeige aufgerufen)
    public function show_menu()
         {
              echo("    <div class=\"css_save_default_title\">\n");
              echo("        <p class=\"css_save_default_title_text\">".$_SESSION["Plate_Facts"]["Name"]."</p>\n");
              echo("    </div>\n"); 
              echo("    <div class=\"css_save_default\">\n");
              echo("        <p class=\"css_save_default_text\">".self::TEXT_SAVE."</p>\n");
              echo("        <input class=\"css_save_default_field\" name=\"Cl_Save_Default[Plate_Name]\" type=\"text\" maxlength=\"32\" value=\"".$_SESSION["Plate_Facts"]["Name"]."\">\n"); 
              echo("        <input name=\"Cl_Save_Default[Skip_Empty]\" class=\"css_save_default_radio_1\" type=\"Radio\" value=\"1\"".$_SESSION["Cl_Save_Default"]["Skip_Empty"][1]."><p class=\"css_save_default_text_1\">".self::TEXT_SELECTED."</p>\n");
              echo("        <input name=\"Cl_Save_Default[Skip_Empty]\" class=\"css_save_default_radio_2\" type=\"Radio\" value=\"2\"".$_SESSION["Cl_Save_Default"]["Skip_Empty"][2]."><p class=\"css_save_default_text_2\">".self::TEXT_ALL."</p>\n"); 
              echo("        <p class=\"css_save_default_decimal\">".self::TEXT_DECIMAL."</p>\n");
              echo("        <input name=\"Cl_Save_Default[Decimal]\" class=\"css_save_default_radio_3\" type=\"Radio\" value=\"1\"".$_SESSION["Cl_Save_Default"]["Decimal"][1]."><p class=\"css_save_default_text_3\">".self::TEXT_POINT."</p>\n"); 
              echo("        <input name=\"Cl_Save_Default[Decimal]\" class=\"css_save_default_radio_4\" type=\"Radio\" value=\"2\"".$_SESSION["Cl_Save_Default"]["Decimal"][2]."><p class=\"css_save_default_text_4\">".self::TEXT_COMMA."</p>\n");
              echo("        <input class=\"css_save_default_button\" name=\"Cl_Save_Default[Save]\" type=\"submit\" value=\"".self::TEXT_EXPORT."\"></br>\n");       
              echo("    </div>\n");    
         }
      //WICHTIG: In jeder Save-Klasse ntig (Wird von main beim Erhalt von Formulardaten aufgerufen)   
      public function on_request()
        {
          //Daten exportieren?
          if(isset($_REQUEST["Cl_Save_Default"]["Save"])) 
              {
                  //Welcher Name fr Platte
                  $_SESSION["Plate_Facts"]["Name"] = preg_replace("/[^\+\-0-9aA-zZ\_\s]/","",html_entity_decode($_REQUEST["Cl_Save_Default"]["Plate_Name"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                  $_SESSION["Plate_Facts"]["Name"] = trim(preg_replace("/\s{1,}/"," ",$_SESSION["Plate_Facts"]["Name"])); //berflssige Leerzeichen entfernen
                  //Welches Dezimaltrennzeichen fr die Zahlen benutzen$
                  if($_REQUEST["Cl_Save_Default"]["Decimal"] == 1)   
                  {
                      $_SESSION["Cl_Save_Default"]["Decimal"][1] = "checked=\"checked\"";
                      $_SESSION["Cl_Save_Default"]["Decimal"][2] = "";
                      $_SESSION["Cl_Save_Default"]["Decimal"]["Char"] = ".";
                  }
                  else    
                  {
                      $_SESSION["Cl_Save_Default"]["Decimal"][1] = "";
                      $_SESSION["Cl_Save_Default"]["Decimal"][2] = "checked=\"checked\"";
                      $_SESSION["Cl_Save_Default"]["Decimal"]["Char"] = ",";
                  }
                  //Feld Leer oder nur ungltige Zeichen? nicht akzeptieren!
                  if(str_replace(array(" ",".","\\","/"),"",$_SESSION["Plate_Facts"]["Name"]) == "") {$_SESSION["Plate_Facts"]["Name"] = self::TEXT_NAME_DEFAULT;}
                  if(isset($_REQUEST["Cl_Save_Default"]["Skip_Empty"]) && $_REQUEST["Cl_Save_Default"]["Skip_Empty"] == 1)    //Speichern, ob "Alles speichern" aktiviert wurde
                  {
                      $_SESSION["Cl_Save_Default"]["Skip_Empty"][1] = "checked=\"checked\"";
                      $_SESSION["Cl_Save_Default"]["Skip_Empty"][2] = "";
                      $this->save_export(2);
                  }
                  elseif(isset($_REQUEST["Cl_Save_Default"]["Skip_Empty"]) && $_REQUEST["Cl_Save_Default"]["Skip_Empty"] == 2)    //Speichern, ob "Nur selektierte speichern" aktiviert wurde
                  {
                      $_SESSION["Cl_Save_Default"]["Skip_Empty"][1] = "";
                      $_SESSION["Cl_Save_Default"]["Skip_Empty"][2] = "checked=\"checked\"";
                      $this->save_export(1);
                  }
                  //Anzeige steuern (Alle Mens anzeigen)
                  $_SESSION["Main"]["Show"] = MAIN_MODE_ALL;
              }
        }
    //WICHTIG: In jeder Save-Klasse ntig. Stellt die Read-Funktion fr von ihr erstellte Daten bereit. bentigt den Parameter $filepath. Gibt TRUE bei Erfolg oder FALSE bei Fehlschlag zurck
    public function read_file($filepath)
        {
            //CSV-DATEIEN EINLESEN
            /*Hochgeladene Datei an Datenstream anbinden*/
            $file = @fopen($filepath,"r");
            //bei Fehlschlag abbrechen
            if($file === FALSE){return(FALSE);}
            
            $line = array();      /*Array fr die Zeilen*/
            $own_csv_file = array();  /*Array fr die komplette Datei*/
            $m=0;                 /*Zhlvariable*/
            /*Bis zum Ende der Datei Zeilen auslese*/
            while (!feof($file)) 
                {
                    $line = fgetcsv($file,0,";");
                    //Nur Wenn das Auslesen einer CSV-Zeile funktioniert, diese auch dem Dateiarray hinzufgen (ACHTUNG: Typvergleich !==, da sonst mit dem String "FALSE" verglichen wird!)
                    if(($line !== FALSE));
                        {
                            $own_csv_file[$m] = $line;
                            $m++;
                        }
                }
            /*Stream schlieen (hochgeladene Datei wird als temporre Datei automatisch von PHP gelscht)*/
            fclose($file);
            
            //Dateifu auslesen
            $footline = count($own_csv_file)-2;
            //ist der Dateifu zu kurz? Abbrechen!
            if(count($own_csv_file[$footline])<8){return(FALSE);}
            
            $program = htmlentities($own_csv_file[$footline][0],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");    //Programmname
            $save_module = htmlentities($own_csv_file[$footline][4],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");    //benutztes Save-Modul
            $plate_area = intval(htmlentities($own_csv_file[$footline][7],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));  //Plattengre
            $analysis_module = htmlentities($own_csv_file[$footline][5],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");  //benutztes Analysemodul (Wird getestet, fhrt bei Fehler aber nicht zu Abbruch!)
            $parameters = intval(htmlentities($own_csv_file[$footline][6],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));  //Ergebnissparameter 
            
            //Dateifu finden, der Lesbarkeit angibt (Programm und Save-Modul-Name mssen bereinstimmen, Plattengre darf nicht 0 sein!)
            if($program != PROGRAMM || $save_module != $_SESSION["Module"]["Save"]["Type"] || $plate_area == 0) {return(FALSE);}
            
            //Ansonsten Daten verarbeiten  
            $_SESSION["Plate_Facts"]["Area"] = $plate_area; 
              
            //Versuchen, das passende Analysemodul zu laden
            if(class_exists($analysis_module) === TRUE) //bereinstimmung mit Analyseklasse in Dateifu? Laden und Schleife abbrechen!
                {
                    load_module($_SESSION["Module"]["Analysis"]["Type"],$analysis_module); //Analysemodul laden
                }
            //Keins gefunden? Dann Fehlerklasse anzeigen
            else
                {
                    load_module($_SESSION["Module"]["Settings"]["Type"],MAIN_NOANALYSIS_AE,TRUE); //Fehler-Analysemodul laden und Fehler anzeigen
                }
                           
            //Plattendaten zurcksetzen & Array neu aufbauen
            $_SESSION["Module"]["Plate"]["Active"]->reset_data();
            $_SESSION["Module"]["Plate"]["Active"]->prepare_plate();
            
            //Line zerlegen (von wo bis wo gehen Parameter-und Datenbereich? (beides variabel)
            $par_begin_end = array("begin"=>3,"end"=>2+$parameters);
            
            $data_begin_end = array("begin"=>$par_begin_end["end"]+1,"end"=>0);
            $data_begin_end["end"] = (count($own_csv_file[0])-$data_begin_end["begin"])/2+$par_begin_end["end"];  //Die eine Hlfte des nach dem letzten Parameter folgenden Teils sind Messdaten,... 
            $model_begin_end = array("begin"=>$data_begin_end["end"]+1,"end"=>count($own_csv_file[0])-1);          //...die andere Modelldaten
            /*Daten bertragen*/         
            for($m=1; $m<count($own_csv_file);$m++)
                {
                    //Well bestimmen
                    $i = $own_csv_file[$m][0];
                    //Bei nicht vorhandener, zu kurzer oder leerer Zeile sowie nach der max. Well-Zahl abbrechen (Ende des Well-Bereichs erreicht)
                    if(!isset($own_csv_file[$m]) || count($own_csv_file[$m]) < ($parameters+3) || $own_csv_file[$m][0] == 0 || $m > ($_SESSION["Plate_Facts"]["Area"]+1)) break;
                    //Wellnamen und Detektor einlesen
                    $_SESSION["Plate_Data"][$i]["Name"]["Well"] = htmlentities($own_csv_file[$m][1],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");
                    $_SESSION["Plate_Data"][$i]["Name"]["Detector"] = htmlentities($own_csv_file[$m][2],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");
                    //Ergebnissparameter einlesen
                    for($a=0; $a<$parameters;$a++)
                        {
                            $_SESSION["Plate_Data"][$i]["Results"][$a]["ID"] = str_replace(",",".",htmlentities($own_csv_file[0][$par_begin_end["begin"]+$a],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1")); //mgliche Kommata durch Punkte ersetzen
                            $_SESSION["Plate_Data"][$i]["Results"][$a]["Value"] = str_replace(",",".",htmlentities($own_csv_file[$m][$par_begin_end["begin"]+$a],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                        }
                    //Messdaten und Moddeldaten einlesen (symetrisch)
                    if(strlen(htmlentities($own_csv_file[$m][$data_begin_end["begin"]],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1")) < 1){continue;} //Wenn kein Messwert vorhanden ist, kann direkt eine Zeile weiter gesprungen werden
                    for($d=0; $d<=$data_begin_end["end"]-$data_begin_end["begin"];$d++)
                        {
                            
                            $_SESSION["Plate_Data"][$i]["Measured_Data"][$d] = str_replace(",",".",htmlentities($own_csv_file[$m][$data_begin_end["begin"]+$d],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1")); //mgliche Kommata durch Punkte ersetzen   
                            $_SESSION["Plate_Data"][$i]["Computed_Data"][$d] = str_replace(",",".",htmlentities($own_csv_file[$m][$model_begin_end["begin"]+$d],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                        }
                }
            return(TRUE);      
        }    
         
    private function save_export($par_skip=0)
         {
            //Hash der Session ID erstellen, von Sonderzeichen befreien und Teil an Dateinamen anhngen
            $hashsession = str_replace(array(" ",".","\\","/"),"c",stristr(crypt(session_id(), '$2y$05$mfd345ef098vscvxxw572'),"."));
            //Wenn kein Dateiname gesetzt ist, einen 
            if(!isset($_SESSION["Plate_Facts"]["Name"])) {$_SESSION["Plate_Facts"]["Name"] = self::TEXT_NAME_DEFAULT;}
            //Dateiname mit Anhang aus Session-ID-Hash erstellen
            $filename = self::DIR_EXPORT.$_SESSION["Plate_Facts"]["Name"]."_".$hashsession.".csv";
            //Daten schreiben
            //Die wie vielte Aktualisierung?
            $_SESSION["Cl_Save_Default"]["Actual"] = $_SESSION["Cl_Save_Default"]["Actual"]+1;
            $newfile = fopen($filename,"w");
            //Daten in CSV-Datei speichern
            for($i=0; $i<count($_SESSION["Plate_Data"]);$i++)
                {
                    if($i==0) //Erste Zeile: Beschriftungen"Data"=>"Messwerte","Computed_Data"=>"Berechnete Werte"
                    {
                        //Start mit Namen des ersten Ergebnissparameters
                        $names_results = $_SESSION["Plate_Data"][1]["Results"][0]["ID"]; 
                        for($a=1; $a<count($_SESSION["Plate_Data"][1]["Results"]); $a++)
                        {
                            $names_results = $names_results.";".$_SESSION["Plate_Data"][1]["Results"][$a]["ID"];  //Namen der Ergebnissparameter verketten
                        }
                        //Start mit Namen des ersten Messwerts und ersten Modellwertes
                        $names_data = self::TEXT_SAVE_DATA." 1"; 
                        $names_data_computed = self::TEXT_SAVE_DATA_COMPUTED." 1"; 
                        //Well mit den meisten Daten finden
                        $last_well=array(1);
                        for($x=1; $x<count($_SESSION["Plate_Data"]); $x++)
                        {
                            $last_well[$x] = count($_SESSION["Plate_Data"][$x]["Measured_Data"]); //Lnge der Daten des Wells ermitteln
                        }
                        $Data_Length = bc_max($last_well); //Lngste Well-Array = Zhlwert fr alle anderen Funktionen mit Messwertarray
                        //Start mit Namen des ersten Messwerts und ersten Modellwertes
                        for($b=2; $b<$Data_Length+1; $b++)
                        {
                            $names_data = $names_data.";".self::TEXT_SAVE_DATA." ".$b; //Namen der Messwerte verketten
                            $names_data_computed = $names_data_computed.";".self::TEXT_SAVE_DATA_COMPUTED." ".$b; //Namen der Modellwerte verketten
                        }
                        //Namenszeile (0) schreiben
                        fwrite($newfile,self::TEXT_SAVE_NR.";".self::TEXT_SAVE_WELL.";".self::TEXT_SAVE_DETECTOR.";".$names_results.";".$names_data.";".$names_data_computed.chr(10));
                    }   
                    //Nicht selektiert oder kein Selektionsfeld und "Nur selektierte whlen" eingeschaltet: berspringen
                    elseif($_SESSION["Plate_Checkbox"][$i] <= 0 && $par_skip == 2) {continue;}
                    //Ansonsten: Werte in Zeile zusammenfassen
                    else  
                    {
                        //Start mit Wert des ersten Ergebnissparameters
                        if(isset($_SESSION["Plate_Data"][$i]["Results"][0]["Value"])) {$values_results = str_replace(".",$_SESSION["Cl_Save_Default"]["Decimal"]["Char"],$_SESSION["Plate_Data"][$i]["Results"][0]["Value"]);} 
                        else {$values_results = self::TEXT_SAVE_NO_RESULTS_VALUE;} 
                        for($a=1; $a<count($_SESSION["Plate_Data"][1]["Results"]); $a++)
                        {
                            $values_results = $values_results.";".str_replace(".",$_SESSION["Cl_Save_Default"]["Decimal"]["Char"],$_SESSION["Plate_Data"][$i]["Results"][$a]["Value"]);  //Namen der Ergebnissparameter verketten
                        }
                        //Start mit Wert des ersten Messwerts und ersten Modellwertes
                        if(isset($_SESSION["Plate_Data"][$i]["Measured_Data"][0])) {$values_data = str_replace(".",$_SESSION["Cl_Save_Default"]["Decimal"]["Char"],$_SESSION["Plate_Data"][$i]["Measured_Data"][0]);} //Existiert fr diese Position ein Messwert? 
                        else {$values_data = self::TEXT_SAVE_NO_DATA_VALUE;} 
                        if(isset($_SESSION["Plate_Data"][$i]["Computed_Data"][0])) {$values_data_computed =str_replace(".",$_SESSION["Cl_Save_Default"]["Decimal"]["Char"],$_SESSION["Plate_Data"][$i]["Computed_Data"][0]);} //Existiert fr diese Position ein Modellwert? (= Wurde der entsprechende Messwert eingeschlossen?)
                        else {$values_data_computed = self::TEXT_SAVE_NO_MODEL_VALUE;} 
                        for($b=1; $b<$Data_Length; $b++)
                        {
                            if(isset($_SESSION["Plate_Data"][$i]["Measured_Data"][$b])) {$values_data = $values_data.";".str_replace(".",$_SESSION["Cl_Save_Default"]["Decimal"]["Char"],$_SESSION["Plate_Data"][$i]["Measured_Data"][$b]);} //Existiert fr diese Position ein Messwert? 
                            else {$values_data = $values_data.";".self::TEXT_SAVE_NO_DATA_VALUE;} 
                            if(isset($_SESSION["Plate_Data"][$i]["Computed_Data"][$b])) {$values_data_computed = $values_data_computed.";".str_replace(".",$_SESSION["Cl_Save_Default"]["Decimal"]["Char"],$_SESSION["Plate_Data"][$i]["Computed_Data"][$b]);} //Existiert fr diese Position ein Modellwert? (= Wurde der entsprechende Messwert eingeschlossen?)
                            else {$values_data_computed = $values_data_computed.";".self::TEXT_SAVE_NO_MODEL_VALUE;} 
                        }
                        //Wertezeile fr Well ($i) schreiben
                        fwrite($newfile,$i.";".$_SESSION["Plate_Data"][$i]["Name"]["Well"].";".$_SESSION["Plate_Data"][$i]["Name"]["Detector"].";".$values_results.";".$values_data.";".$values_data_computed.chr(10));
                    }   
                }
            //Leerzeile, um Dateiinformation abzutrennen
            fwrite($newfile,chr(10));
            //Statuszeile Hinzufgen, die das sptere Laden ermglicht
            //Programm|Version|Nebenversion|Patch|benutztes Savemodul|benutztes Analysemodul|Ergebnissparameter|Plattengre
            $result_pars = count($_SESSION["Plate_Data"][1]["Results"]);
            fwrite($newfile,self::FOOT_PROGRAMM.";".self::FOOT_MAJOR.";".self::FOOT_MINOR.";".self::FOOT_PATCH.";".self::FOOT_MODULE_SAVE.";".self::FOOT_MODULE_ANALYSIS.";".self::FOOT_RESULT_PAR.";".self::FOOT_PLATE.chr(10));
            fwrite($newfile,PROGRAMM.";".MAJOR_RELEASE.";".MINOR_RELEASE.";".PATCH_LEVEL.";".$_SESSION["Module"]["Save"]["Type"].";".$_SESSION["Module"]["Analysis"]["Type"].";".$result_pars.";".$_SESSION["Plate_Facts"]["Area"].chr(10));
            fclose($newfile);
            //Link zu Datei bereitstellen
            echo("    <div class=\"css_save_default_link\">\n");
            echo("        <a class=\"css_save_default_link_text\" href=\"".$filename."\">".self::TEXT_LINK_1.$_SESSION["Cl_Save_Default"]["Actual"].self::TEXT_LINK_2."</a>\n");
            echo("    </div>\n"); 
         } 
} 
?>