<?php
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

/*Script zum Einstellen und Anzeigen der Analyse fr alle selektierten Wells*/
class cl_settings_ds
{
    //The menu texts are defined as constants, so that an adjustment in other language is fast possible
    const TEXT_LOOPS = "Loops:";
    const TEXT_ROUNDS = "Cycles:";
    const TEXT_RULES = "Optimization rules ";
    const TEXT_STEP_1 = " after 10%";
    const TEXT_STEP_2= " after 50%";
    const TEXT_STEP_3 = " after 75%";
    const TEXT_TARGET = "Target-";
    const TEXT_PARAMETER = "Downhill-Simplex parameters";
    const TEXT_REFLEXION = "Reflection:";
    const TEXT_EXPANSION = "Expansion:";
    const TEXT_CONTRACTION = "Contraction:";
    const TEXT_LOG_TITLE = "Logfile";
    const TEXT_LOG_NON = "Minimal";
    const TEXT_LOG_NORMAL = "Normal";
    const TEXT_LOG_FULL = "Full";
    const TEXT_START = "Start analysis";
    const TEXT_STOP = "Cancel";
    const TEXT_WELL = "Well";
    const TEXT_SKIP = "Next well";
    //Die Defaultwerte fr die einzelnen Parameter
    const DEFAULT_LOOPS = 100;
    const DEFAULT_ROUNDS = 2000;
    const DEFAULT_PRECISION = "0.00009";
    const DEFAULT_STEP_1 = "0.09";
    const DEFAULT_STEP_2 = "0.009";
    const DEFAULT_STEP_3 = "0.0009";
    const DEFAULT_REFLEXION = 2;
    const DEFAULT_EXPANSION = 2;
    const DEFAULT_CONTRACTION = "0.5";
    const DEFAULT_REPEAT_BARRIER = 2;      //Bricht den Downhill-Simplex-Vorgang ab, wenn immer wieder auf das selbe Ergebnis optimiert wird. (Nicht im Men reprsentiert)
   
    //WICHTIG: In jeder Settings-Klasse ntig (Wird von main beim ersten Start des Programms aufgerufen. Sollte dann berprfen, ob bereits Voreinstellungen vom Analyseobjekt vorgenommen wurden und ansonsten selbst die Voreinstellungen laden)     
    public static function firststart()
         {
              /*Initialisierung der vom Objekt eingefhrten, durch preset() beeinflussten $SESSION-Variablen nur, wenn diese noch nicht gesetzt sind*/
              /*Werden in $_SESSION["Cl_Settings_DS"]["Preset"] bergeben, da durch dynamisches include() der PHP-Klassendateien keine static-variablen benutzbar sind (Diese wrden nach jedem Aktualisieren zurckgesetzt!)*/
              if(!isset($_SESSION["Cl_Settings_DS"]["Preset"]))
                  {
                      $_SESSION["Cl_Settings_DS"]["Preset"]["Loops"] = self::DEFAULT_LOOPS;
                      $_SESSION["Cl_Settings_DS"]["Preset"]["Rounds"] = self::DEFAULT_ROUNDS;
                      $_SESSION["Cl_Settings_DS"]["Preset"]["Precision"] = self::DEFAULT_PRECISION;
                      $_SESSION["Cl_Settings_DS"]["Preset"]["Step_1"] = self::DEFAULT_STEP_1;
                      $_SESSION["Cl_Settings_DS"]["Preset"]["Step_2"] = self::DEFAULT_STEP_2;
                      $_SESSION["Cl_Settings_DS"]["Preset"]["Step_3"] = self::DEFAULT_STEP_3;
                      $_SESSION["Cl_Settings_DS"]["Preset"]["Reflexion"] = self::DEFAULT_REFLEXION;
                      $_SESSION["Cl_Settings_DS"]["Preset"]["Expansion"] = self::DEFAULT_EXPANSION;
                      $_SESSION["Cl_Settings_DS"]["Preset"]["Contraction"] = self::DEFAULT_CONTRACTION;
                      $_SESSION["Cl_Settings_DS"]["Preset"]["Repeat_Barrier"] = self::DEFAULT_REPEAT_BARRIER;
                  }
              /*Alle anderen $_SESSION-variablen des Objekts normal initialisieren*/
              $_SESSION["Cl_Settings_DS"]["Logfile"][0] = "";
              $_SESSION["Cl_Settings_DS"]["Logfile"][1] = "checked=\"checked\"";
              $_SESSION["Cl_Settings_DS"]["Logfile"][2] = "";
              $_SESSION["Cl_Settings_DS"]["Logfile"]["Log"] = 1;  
         }
    
    //WICHTIG: In jeder Settings-Klasse ntig (Kann vom gewhlten Analyseobjekt mit variabler Anzahl von Parametern aufgerufen werden, um die Voreinstellungen anzupassen) 
    public static function presets($a=NULL,$b=NULL,$c=NULL,$d=NULL,$e=NULL,$f=NULL,$g=NULL,$h=NULL,$i=NULL,$j=NULL)
         {
              /*Initialisierung der vom Objekt benutzten Standartwert-Variablen*/ 
              if($a !== NULL){$_SESSION["Cl_Settings_DS"]["Preset"]["Loops"] = $a;}
              if($b !== NULL){$_SESSION["Cl_Settings_DS"]["Preset"]["Rounds"] = $b;} 
              if($c !== NULL){$_SESSION["Cl_Settings_DS"]["Preset"]["Precision"] = $c;}
              if($d !== NULL){$_SESSION["Cl_Settings_DS"]["Preset"]["Step_1"] = $d;}
              if($e !== NULL){$_SESSION["Cl_Settings_DS"]["Preset"]["Step_2"] = $e;}
              if($f !== NULL){$_SESSION["Cl_Settings_DS"]["Preset"]["Step_3"] = $f;}
              if($g !== NULL){$_SESSION["Cl_Settings_DS"]["Preset"]["Reflexion"] = $g;}
              if($h !== NULL){$_SESSION["Cl_Settings_DS"]["Preset"]["Expansion"] = $h;}
              if($i !== NULL){$_SESSION["Cl_Settings_DS"]["Preset"]["Contraction"] = $i;}
              if($j !== NULL){$_SESSION["Cl_Settings_DS"]["Preset"]["Repeat_Barrier"] = $j;}   
         }
         
    //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim Wechsel auf ein anderes Modul aufgerufen)
    public static function unload()
         {
              /*Lschen der vom Objekt eingefhrten $SESSION-Variablen*/ 
              unset($_SESSION["Cl_Settings_DS"]); 
         }  
   
    //WICHTIG: In jeder Settings-Klasse ntig (Wird von main.php zur Einblendung des Optionsmens aufgerufen) 
    public function show_menu()
         {
              echo("<div class=\"css_settings_ds\">\n");
              echo("    <div class=\"css_settings_ds_options\">\n"); 
              echo("        <p class=\"css_settings_ds_text_1\">".self::TEXT_LOOPS."</p><input class=\"css_settings_ds_loops\" name=\"Cl_Settings_DS[Loops]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Cl_Settings_DS"]["Loops"]."\">\n");
              echo("        <p class=\"css_settings_ds_text_2\">".self::TEXT_ROUNDS."</p><input class=\"css_settings_ds_rounds\" name=\"Cl_Settings_DS[Rounds]\" type=\"text\" maxlength=\"5\" value=\"".$_SESSION["Cl_Settings_DS"]["Rounds"]."\">\n");
              echo("        <p class=\"css_settings_ds_text_3\">".self::TEXT_RULES."</p>");
              echo("        <p class=\"css_settings_ds_text_4\">".$_SESSION["Plate_Data"][1]["Results"][1]["ID"].self::TEXT_STEP_1."</p><input class=\"css_settings_ds_firststep\" name=\"Cl_Settings_DS[Step_1]\" type=\"text\" maxlength=\"8\" value=\"".$_SESSION["Cl_Settings_DS"]["Step_1"]."\">\n"); 
              echo("        <p class=\"css_settings_ds_text_5\">".$_SESSION["Plate_Data"][1]["Results"][1]["ID"].self::TEXT_STEP_2."</p><input class=\"css_settings_ds_secondstep\" name=\"Cl_Settings_DS[Step_2]\" type=\"text\" maxlength=\"8\" value=\"".$_SESSION["Cl_Settings_DS"]["Step_2"]."\">\n");
              echo("        <p class=\"css_settings_ds_text_6\">".$_SESSION["Plate_Data"][1]["Results"][1]["ID"].self::TEXT_STEP_3."</p><input class=\"css_settings_ds_thirdstep\" name=\"Cl_Settings_DS[Step_3]\" type=\"text\" maxlength=\"8\" value=\"".$_SESSION["Cl_Settings_DS"]["Step_3"]."\">\n");
              echo("        <p class=\"css_settings_ds_text_7\">".self::TEXT_TARGET.$_SESSION["Plate_Data"][1]["Results"][1]["ID"]."</p><input class=\"css_settings_ds_precision\" name=\"Cl_Settings_DS[Precision]\" type=\"text\" maxlength=\"8\" value=\"".$_SESSION["Cl_Settings_DS"]["Precision"]."\">\n");
              echo("        <p class=\"css_settings_ds_startpoint\">".self::TEXT_PARAMETER."</p>\n"); 
              echo("        <p class=\"css_settings_ds_text_8\">".self::TEXT_REFLEXION."</p><input class=\"css_settings_ds_ref\" name=\"Cl_Settings_DS[Reflexion]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Cl_Settings_DS"]["Reflexion"]."\">\n"); 
              echo("        <p class=\"css_settings_ds_text_9\">".self::TEXT_EXPANSION."</p><input class=\"css_settings_ds_ex\" name=\"Cl_Settings_DS[Expansion]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Cl_Settings_DS"]["Expansion"]."\">\n");
              echo("        <p class=\"css_settings_ds_text_10\">".self::TEXT_CONTRACTION."</p><input class=\"css_settings_ds_kon\" name=\"Cl_Settings_DS[Contraction]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Cl_Settings_DS"]["Contraction"]."\">\n");     
              echo("        <p class=\"css_settings_ds_log\">".self::TEXT_LOG_TITLE."</p>\n"); 
              echo("        <input class=\"css_settings_ds_log_none\" name=\"Cl_Settings_DS[Logfile]\" type=\"Radio\" ".$_SESSION["Cl_Settings_DS"]["Logfile"][0]." value=\"1\"><p class=\"css_settings_ds_text_11\">".self::TEXT_LOG_NON."</p>\n"); 
              echo("        <input class=\"css_settings_ds_log_normal\" name=\"Cl_Settings_DS[Logfile]\" type=\"Radio\" ".$_SESSION["Cl_Settings_DS"]["Logfile"][1]." value=\"2\"><p class=\"css_settings_ds_text_12\">".self::TEXT_LOG_NORMAL."</p>\n");
              echo("        <input class=\"css_settings_ds_log_full\" name=\"Cl_Settings_DS[Logfile]\" type=\"Radio\" ".$_SESSION["Cl_Settings_DS"]["Logfile"][2]." value=\"3\"><p class=\"css_settings_ds_text_13\">".self::TEXT_LOG_FULL."</p>\n");     
              echo("        <input class=\"css_settings_ds_button_1\" name=\"Cl_Settings_DS[Run_Analysis]\" type=\"submit\" value=\"".self::TEXT_START."\">\n");
              //Button zum Abbrechen einfgen
              echo("        <input class=\"css_settings_ds_button_2\" name=\"Cl_Settings_DS[Cancel]\" type=\"submit\" value=\"".self::TEXT_STOP."\">\n");
              echo("    </div>\n");
              echo("</div>\n");
         }
    
    //WICHTIG: In jeder Klasse ntig. bertragene Daten aus Analyseformular kontrollieren (ACHTUNG: viele Global-Aufrufe sind mit @ versehen, da die entsprechenden Indizes je nach Formularaktion nicht vergeben sind!)    
    function on_request()/*Funktion berprft die vom Formular bertragenen Daten*/
         {
              //Analyseparameter laden
              $_SESSION["Cl_Settings_DS"]["Loops"] = intval(htmlentities(@$_REQUEST["Cl_Settings_DS"]["Loops"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
              $_SESSION["Cl_Settings_DS"]["Rounds"] = intval(htmlentities(@$_REQUEST["Cl_Settings_DS"]["Rounds"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
              //Bei Komma-Werten automatisch Komma durch Punkt ersetzen
              $_SESSION["Cl_Settings_DS"]["Precision"] = str_replace(",",".",htmlentities(@$_REQUEST["Cl_Settings_DS"]["Precision"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
              $_SESSION["Cl_Settings_DS"]["Step_1"] = str_replace(",",".",htmlentities(@$_REQUEST["Cl_Settings_DS"]["Step_1"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
              $_SESSION["Cl_Settings_DS"]["Step_2"] = str_replace(",",".",htmlentities(@$_REQUEST["Cl_Settings_DS"]["Step_2"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
              $_SESSION["Cl_Settings_DS"]["Step_3"] = str_replace(",",".",htmlentities(@$_REQUEST["Cl_Settings_DS"]["Step_3"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
              $_SESSION["Cl_Settings_DS"]["Reflexion"] = str_replace(",",".",htmlentities(@$_REQUEST["Cl_Settings_DS"]["Reflexion"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
              $_SESSION["Cl_Settings_DS"]["Expansion"] = str_replace(",",".",htmlentities(@$_REQUEST["Cl_Settings_DS"]["Expansion"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
              $_SESSION["Cl_Settings_DS"]["Contraction"] = str_replace(",",".",htmlentities(@$_REQUEST["Cl_Settings_DS"]["Contraction"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
              //Analyseparameter berprfen (Wenn Werte in ungltigem Bereich --> zurck
              if($_SESSION["Cl_Settings_DS"]["Loops"] <= 0){$_SESSION["Cl_Settings_DS"]["Loops"] = $_SESSION["Cl_Settings_DS"]["Preset"]["Loops"];}
              if($_SESSION["Cl_Settings_DS"]["Rounds"] <= 0){$_SESSION["Cl_Settings_DS"]["Rounds"] = $_SESSION["Cl_Settings_DS"]["Preset"]["Rounds"];}
              if(!is_numeric($_SESSION["Cl_Settings_DS"]["Precision"])){$_SESSION["Cl_Settings_DS"]["Precision"] = $_SESSION["Cl_Settings_DS"]["Preset"]["Precision"];}
              if(!is_numeric($_SESSION["Cl_Settings_DS"]["Step_1"])){$_SESSION["Cl_Settings_DS"]["Step_1"] = $_SESSION["Cl_Settings_DS"]["Preset"]["Step_1"];}
              if(!is_numeric($_SESSION["Cl_Settings_DS"]["Step_2"])){$_SESSION["Cl_Settings_DS"]["Step_2"] = $_SESSION["Cl_Settings_DS"]["Preset"]["Step_2"];}
              if(!is_numeric($_SESSION["Cl_Settings_DS"]["Step_3"])){$_SESSION["Cl_Settings_DS"]["Step_3"] = $_SESSION["Cl_Settings_DS"]["Preset"]["Step_3"];}
              if(!is_numeric($_SESSION["Cl_Settings_DS"]["Reflexion"])){$_SESSION["Cl_Settings_DS"]["Reflexion"] = $_SESSION["Cl_Settings_DS"]["Preset"]["Reflexion"];}
              if(!is_numeric($_SESSION["Cl_Settings_DS"]["Expansion"])){$_SESSION["Cl_Settings_DS"]["Expansion"] = $_SESSION["Cl_Settings_DS"]["Preset"]["Expansion"];}
              if(!is_numeric($_SESSION["Cl_Settings_DS"]["Contraction"])){$_SESSION["Cl_Settings_DS"]["Contraction"] = $_SESSION["Cl_Settings_DS"]["Preset"]["Contraction"];}
              //Welcher Log-Modus wurde gewhlt?
              if(isset($_REQUEST["Cl_Settings_DS"]["Logfile"]) && $_REQUEST["Cl_Settings_DS"]["Logfile"] == 1)
                  {
                      $_SESSION["Cl_Settings_DS"]["Logfile"][0] = "checked=\"checked\"";
                      $_SESSION["Cl_Settings_DS"]["Logfile"][1] = "";
                      $_SESSION["Cl_Settings_DS"]["Logfile"][2] = "";
                      $_SESSION["Cl_Settings_DS"]["Logfile"]["Log"] = 0;   
                  }
              if(isset($_REQUEST["Cl_Settings_DS"]["Logfile"]) && $_REQUEST["Cl_Settings_DS"]["Logfile"] == 2)
                  {
                      $_SESSION["Cl_Settings_DS"]["Logfile"][0] = "";
                      $_SESSION["Cl_Settings_DS"]["Logfile"][1] = "checked=\"checked\"";
                      $_SESSION["Cl_Settings_DS"]["Logfile"][2] = "";
                      $_SESSION["Cl_Settings_DS"]["Logfile"]["Log"] = 1;   
                  }
              if(isset($_REQUEST["Cl_Settings_DS"]["Logfile"]) && $_REQUEST["Cl_Settings_DS"]["Logfile"] == 3)
                  { 
                      $_SESSION["Cl_Settings_DS"]["Logfile"][0] = "";
                      $_SESSION["Cl_Settings_DS"]["Logfile"][1] = "";
                      $_SESSION["Cl_Settings_DS"]["Logfile"][2] = "checked=\"checked\"";
                      $_SESSION["Cl_Settings_DS"]["Logfile"]["Log"] = 2;   
                  }
              //Well berspringen?
              if(isset($_REQUEST["Cl_Settings_DS"]["Skip"]))
                  {
                      for($i=1;$i < $_SESSION["Plate_Facts"]["Area"]+1;$i++)  
                          {
                              if(isset($_REQUEST["Cl_Settings_DS"]["Skip"][$i])) //Ein Well zum berspringen? 
                                  {
                                      for($k=$i+1;$k < $_SESSION["Plate_Facts"]["Area"]+1;$k++)  
                                          {
                                              if(isset($_SESSION["Plate_Checkbox"][$k]) && $_SESSION["Plate_Checkbox"][$k]>0)//Eines der nachfolgenden Wells gecheckt?
                                                  {
                                                      $_SESSION["Cl_Settings_DS"]["Skip"]=$k;//Wenn Well bersprungen werden soll-> zum Nchsten gecheckten springen
                                                      $_SESSION["Main"]["Show"] = MAIN_MODE_ANALYSIS;
                                                      break 2; //Die beiden Suchschleifen abbrechen und Analyse mit neuem Well starten
                                                  }
                                          }
                                  } 
                          }
                       if($_SESSION["Main"]["Show"] == MAIN_MODE_NONE){$_SESSION["Main"]["Show"] = MAIN_MODE_ALL;}  //Kein Well mehr zum berspringen gefunden? dann Analyse abbrechen
                  }
              else{$_SESSION["Cl_Settings_DS"]["Skip"] = 1;}
              
              //Analyse gestartet?
              if(isset($_REQUEST["Cl_Settings_DS"]["Run_Analysis"]))
                  {
                      $_SESSION["Main"]["Show"] = MAIN_MODE_ANALYSIS;      
                  }
              //Analyse abgebrochen?
              if(isset($_REQUEST["Cl_Settings_DS"]["Cancel"])){$_SESSION["Main"]["Show"] = MAIN_MODE_ALL;}
         }  
         
    //WICHTIG: In jeder Settings-Klasse ntig. Erzeugt Analysobjekt und startet die Analyse.   
    public function run_analysis()
         {
            echo("    <div>\n"); //Log-Div erstellen
            echo("        <input class=\"css_settings_ds_button_3\" name=\"Cl_Settings_DS[Cancel]\" type=\"submit\" value=\"".self::TEXT_STOP."\">\n"); //Abbrechen-Button
           
            //Analyse fr alle ausgewhlten Wells Starten
            for($i=$_SESSION["Cl_Settings_DS"]["Skip"];$i < $_SESSION["Plate_Facts"]["Area"]+1;$i++)  
                {
                    echo("        <input class=\"css_settings_ds_button_4\" name=\"Cl_Settings_DS[Skip][".$i."]\" type=\"submit\" value=\"".self::TEXT_SKIP."\">\n"); //berspringen-Button
                    echo("        <div name=\"logdiv\" class=\"css_settings_ds_log_".$_SESSION["Cl_Settings_DS"]["Logfile"]["Log"]."\">\n"); //Text_Log-Div erstellen (fr jedes Well neu)
                    //Ist Well selektiert? und enthlt es Daten?
                    if($_SESSION["Plate_Checkbox"][$i] > 0 && $_SESSION["Plate_Data"][$i]["Measured_Data"] != 0)
                    {
                        $_SESSION["Module"]["Analysis"]["Active"] = new $_SESSION["Module"]["Analysis"]["Type"];      
                        //Aktuelles Well dokumentieren
                        echo("            ".self::TEXT_WELL.$i."...\n");                    
                        //Analyse fr gewhltes Well starten (Ergebnisse werden durch Analyseobjekt bei Zerstrung automatisch in Plattenarray gespeichert)
                        $_SESSION["Module"]["Analysis"]["Active"]->run_analysis($i,
                                                                             $_SESSION["Plate_Data"][$i]["Measured_Data"],
                                                                             $_SESSION["Cl_Settings_DS"]["Reflexion"],
                                                                             $_SESSION["Cl_Settings_DS"]["Expansion"],
                                                                             $_SESSION["Cl_Settings_DS"]["Contraction"],
                                                                             $_SESSION["Cl_Settings_DS"]["Rounds"],
                                                                             $_SESSION["Cl_Settings_DS"]["Loops"],
                                                                             $_SESSION["Cl_Settings_DS"]["Precision"],
                                                                             $_SESSION["Cl_Settings_DS"]["Step_1"],
                                                                             $_SESSION["Cl_Settings_DS"]["Step_2"],
                                                                             $_SESSION["Cl_Settings_DS"]["Step_3"],
                                                                             $_SESSION["Cl_Settings_DS"]["Preset"]["Repeat_Barrier"],
                                                                             $_SESSION["Cl_Settings_DS"]["Logfile"]["Log"]);
                    }
                    echo("        </div>");
                }             
            echo("    </div>");
            //Am Ende Log-Fenster wieder berdecken
            echo("<div class=\"css_settings_ds_over\"></div>");
         } 
} 
?>