<?php
/*
Copyright 2013 Christoph Bultmann

This file is part of the MAKERGAUL-package.

The MAKERGAUL-package is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The MAKERGAUL-package is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with the MAKERGAUL-package.  If not, see <http://www.gnu.org/licenses/>.
*/

/*Script zum Hochladen, bearbeiten und zurckgeben von *.csv-Dateien (optimiert auf ABI 7300)*/ 
class cl_upload_default
{
    //The menu texts are defined as constants, so that an adjustment in other language is fast possible
    const TEXT_CYCLES = "Cycles: ";
    const TEXT_ALL = "All";
    const TEXT_TYPE = ""; 
    const TEXT_UPLOAD = "Upload / Create new plate";
    const TEXT_PLATE = "Plate";
    const TEXT_WELLS = "Wells; per line";
    const TEXT_ERROR_1 = "File too large (> 1MB).";
    const TEXT_ERROR_2 = "File could not be uploaded completely.";
    const TEXT_ERROR_3 = "Server is not able to cache the file. </ Br> Please contact the system administrator.";
    const TEXT_ERROR_4 = "Server is not able to save the file.</br>please contact the system administrator.";
    const TEXT_ERROR_5 = "Another PHP extension stopped the upload.</br>please contact the system administrator.";
    const TEXT_ERROR_6 = "File appears to be a defective 7300-delta export.";
    const TEXT_ERROR_7 = "File appears to be an erroneous 7300-component exports.";
    const TEXT_ERROR_8 = "File is an unsupported *.csv file. This can be possibly solved by loading the appropriate save &nbspor&nbspupload moduls. </ Br> (module menu change)";
    const TEXT_ERROR_9 = "Plates loaded setup can be added only to existing records!";
    const TEXT_ERROR_10 = "File appears to be a defective 7300 Sample setup export.";
    const TEXT_ERROR_11 = "File is an unsupported *.txt file. This can be possibly solved by loading the appropriate save &nbspor &nbspupload moduls. </ Br> (module menu change)";
    const TEXT_ERROR_12 = "File can not be opened with the currently loaded modules. This can be possibly solved by loading the appropriate save &nbspor&nbspuploadmoduls. </ Br> (module menu change)";
    //Texts of the option menu
    const TEXT_LOADED_DATA = "Data type...";
    const TEXT_7300_DELTA_RN = "7300-Delta RN (*.csv)";
    const TEXT_7300_COMPONENT = "7300-Component (*.csv)";
    const TEXT_7300_SETUP = "7300 Sample-Setup (*.txt, is loaded additive to existing plate)";
    const TEXT_OWN = "own import (*.csv, first line: \"Well\";\"Name\";\"Detector\";\"Cycle 1\";\"Cycle ...\")";
    const TEXT_MAKERGAUL = "MAKERGAUL-file (*.csv)";
    //Skalierungsfaktoren, um unterschiedliche Fluoreszensskalen in den Bereich der Grenzwerte der Analysealgorithmen zu bringen
    const INT_FACTOR_7300_COMPONENT = 1000000;
    
    private $csv_file = array(); //Variable zum Speichern eines CSV-Files
    private $txt_file = array(); //Variable zum Speichern eines TXT-Files
    
    //WICHTIG: In jeder Upload-Klasse ntig (Wird von main beim ersten Start des Programms aufgerufen)
    public static function firststart()
         {
              /*Initialisierung der vom Objekt eingefhrten $SESSION-Variablen*/ 
              $_SESSION["Cl_Upload_Default"]["Cycles"] = self::TEXT_ALL;
              $_SESSION["Cl_Upload_Default"]["Type"]["Value"] = 1;
              $_SESSION["Cl_Upload_Default"]["Type"]["Name"] = self::TEXT_LOADED_DATA;  
         }
     //WICHTIG: In jeder Klasse ntig (Wird von cl_modulechange beim wechsel auf ein anderes Modul aufgerufen)
     public static function unload()
         {
              /*Lschen der vom Objekt eingefhrten $SESSION-Variablen*/ 
              unset($_SESSION["Cl_Upload_Default"]); 
         }  
         
    //WICHTIG: In jeder Upload-Klasse ntig (Wird von main beim Aktualisieren der Anzeige aufgerufen)      
    public function show_menu()
         {
              echo("        <div class=\"css_upload_default\">\n");
              echo("            <form enctype=\"multipart/form-data\" action=\"".$_SESSION["Mainfile"]."\" method=\"post\">\n"); 
              echo("            <div class=\"css_upload_default_1\">\n");       
              echo("                <input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"1000000\">\n");
              echo("                <input class=\"css_upload_default_field_1\" name=\"Cl_Upload_Default_File\" type=\"file\">\n");  
              echo("                <p class=\"css_upload_default_text_2\">".self::TEXT_CYCLES."</p><input class=\"css_upload_default_field_2\" name=\"Cl_Upload_Default[Cycles]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Cl_Upload_Default"]["Cycles"]."\">\n");  
              echo("                <p class=\"css_upload_default_text_1\">".self::TEXT_TYPE."</p>\n");  
              echo("                <select name=\"Cl_Upload_Default[Type][Value]\" class=\"css_upload_default_select\" size=\"1\">\n");  
              echo("                    <option value=\"".$_SESSION["Cl_Upload_Default"]["Type"]["Value"]."\">".$_SESSION["Cl_Upload_Default"]["Type"]["Name"]."</option>\n"); 
              echo("                    <option disabled=\"disabled\" value=\"1\">".self::TEXT_7300_DELTA_RN."</option>\n"); 
              echo("                    <option disabled=\"disabled\" value=\"2\">".self::TEXT_7300_COMPONENT."</option>\n"); 
              echo("                    <option disabled=\"disabled\" value=\"3\">".self::TEXT_7300_SETUP."</option>\n"); 
              echo("                    <option disabled=\"disabled\" value=\"4\">".self::TEXT_MAKERGAUL."</option>\n");  
              echo("                    <option disabled=\"disabled\" value=\"5\">".self::TEXT_OWN."</option>\n");  
              echo("                </select>\n");  
              echo("                <input class=\"css_upload_default_button\" name=\"Cl_Upload_Default[Button]\" type=\"submit\" value=\"".self::TEXT_UPLOAD."\">\n");  //Name des Upload-Button = Name des Requests in on_request()!!!
              echo("            </div>\n");  
              echo("            <div class=\"css_upload_default_options\">\n");  
              echo("                <p class=\"css_upload_default_text_3\">".self::TEXT_PLATE.": </p><input class=\"css_upload_default_field_3\" name=\"Cl_Upload_Default[Area]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Plate_Facts"]["Area"]."\">\n");  
              echo("                <p class=\"css_upload_default_text_4\">".self::TEXT_WELLS."</p><input class=\"css_upload_default_field_4\" name=\"Cl_Upload_Default[Rows]\" type=\"text\" maxlength=\"4\" value=\"".$_SESSION["Plate_Facts"]["Rows"]."\">\n");  
              echo("            </div>\n");  
              echo("            </form>\n");  
              echo("        </div> \n");     
         }  
         
      //WICHTIG: In jeder Upload-Klasse ntig (Wird von main beim Erhalt von Formulardaten aufgerufen)   
      public function on_request()
        {
            //Upload aktiviert?-->Datei kontrollieren
            if(isset($_REQUEST["Cl_Upload_Default"]["Button"])) 
                {
                    //Wells pro Zeile verarbeiten (Plattengre wird automatisch berechnet)
                    $_SESSION["Plate_Facts"]["Rows"] = intval(htmlentities(@$_REQUEST["Cl_Upload_Default"]["Rows"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                    if($_SESSION["Plate_Facts"]["Rows"] <= 0) {$_SESSION["Plate_Facts"]["Rows"] = 12;}//Wenn keine gltige Zahl oder zu kleiner Wert angegeben, Wells auf Standartwert setzen
                    $_SESSION["Select_All"] = "Selektion aufheben"; //Beschriftung ndern (Wechselbutton)
                    //Welche Dateiart?
                    if(isset($_REQUEST["Cl_Upload_Default"]["Type"]["Value"]) && intval(htmlentities(@$_REQUEST["Cl_Upload_Default"]["Type"]["Value"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1")) > 0) {$_SESSION["Cl_Upload_Default"]["Type"]["Value"] = intval(htmlentities(@$_REQUEST["Cl_Upload_Default"]["Type"]["Value"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));} 
                    else {$_SESSION["Cl_Upload_Default"]["Type"]["Value"] = 1;}
                    //Wie viele Zyklen werden importiert?
                    if(isset($_REQUEST["Cl_Upload_Default"]["Cycles"]) && intval(htmlentities(@$_REQUEST["Cl_Upload_Default"]["Cycles"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1")) > 0) {$_SESSION["Cl_Upload_Default"]["Cycles"] = intval(htmlentities(@$_REQUEST["Cl_Upload_Default"]["Cycles"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));} 
                    else {$_SESSION["Cl_Upload_Default"]["Cycles"] = self::TEXT_ALL;} //Ansonsten Zyklen = "ALLE" (Spter wird auf diesen Wert geprft und ggf. die Zyklenabschneidung aufgehoben)
                    //File berprfen
                    $this->check_file();
                }
            //Neue Platte-->Plattengre und Wells pro Zeile
            //Plattengre-Feld nur auslesen, wenn neue Platte erstellt wird (Bei Dateiupload wird Plattengre automatisch festgelegt)
            if(isset($_REQUEST["Cl_Upload_Default"]["Newplate"])) 
              {
                  $_SESSION["Plate_Facts"]["Area"] = intval(htmlentities(@$_REQUEST["Cl_Upload_Default"]["Area"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                  $_SESSION["Plate_Facts"]["Rows"] = intval(htmlentities(@$_REQUEST["Cl_Upload_Default"]["Rows"],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                  //Wenn keine gltige Zahl oder zu kleiner Wert angegeben, Wells auf Standartwert setzen
                  if($_SESSION["Plate_Facts"]["Area"] <= 0) {$_SESSION["Plate_Facts"]["Area"] = 96;}
                  if($_SESSION["Plate_Facts"]["Rows"] <= 0) {$_SESSION["Plate_Facts"]["Rows"] = 12;}
                  
                  //Plattendaten zurcksetzen & Array neu aufbauen
                  $_SESSION["Module"]["Plate"]["Active"]->reset_data();
                  $_SESSION["Module"]["Plate"]["Active"]->prepare_plate();
                  $_SESSION["Main"]["Show"] = $_SESSION["Module"]["Plate"]["Type"];
                  $_SESSION["Cl_Upload_Default"]["Type"]["Name"] = self::TEXT_MAKERGAUL;
              }
        }    
            
    /*Upload kontrollieren*/
    private function check_file()
         {
              /*Dateiupload-->Fehlersuche initiieren, return(-1) =kein Fehler*/
              /*1.Noch gar nichts hochgeladen? Neue Platte erstellen*/
              if(count($_FILES) == 0)
                  {
                      $_REQUEST["Cl_Upload_Default"]["Newplate"]=1;
                      return;     //Zurck zu on_request(), Bedingung zwei wird jetzt erfllt
                  }
              /*2.Datei war zu gro? (>~1MB)*/
              elseif($_SERVER["CONTENT_LENGTH"] >1000000)
                  {
                      $this->show_error(self::TEXT_ERROR_1);
                      return;
                  }
              /*3. Der Upload ist fehlgeschlagen, errorlog auslesen*/
              elseif($_FILES["Cl_Upload_Default_File"]["error"] >0)
                  {
                      if($_FILES["Cl_Upload_Default_File"]["error"] == 1)
                      {
                          $this->show_error(self::TEXT_ERROR_1);
                          return;
                      }
                      elseif($_FILES["Cl_Upload_Default_File"]["error"] == 2)
                      {
                          $this->show_error(self::TEXT_ERROR_1);
                          return;
                      }
                      elseif($_FILES["Cl_Upload_Default_File"]["error"] == 3)
                      {
                          $this->show_error(self::TEXT_ERROR_2);
                          return;
                      }
                      elseif($_FILES["Cl_Upload_Default_File"]["error"] == 4)   //Kein Fehler, sondern leere Platte erstellen
                      {
                          $_REQUEST["Cl_Upload_Default"]["Newplate"]=1;
                          return;     //Zurck zu on_request(), Bedingung zwei wird jetzt erfllt
                      }
                      elseif($_FILES["Cl_Upload_Default_File"]["error"] == 6)
                      {
                          $this->show_error(self::TEXT_ERROR_3);
                          return;
                      }
                      elseif($_FILES["Cl_Upload_Default_File"]["error"] == 7)
                      {
                          $this->show_error(self::TEXT_ERROR_4);
                          return;
                      }
                      elseif($_FILES["Cl_Upload_Default_File"]["error"] == 8)
                      {
                          $this->show_error(self::TEXT_ERROR_5);
                          return;
                      }
                  }
              
              /*5.Alles in Ordnung? nix machen*/
              else
                  {
                      /*Alles in Ordnung? Namen speichern und Datei prozessieren*/
                      $_SESSION["Plate_Facts"]["Name"] = substr($_FILES["Cl_Upload_Default_File"]["name"],0,stripos($_FILES["Cl_Upload_Default_File"]["name"],"."));
                      if($this->process_file() === TRUE){$_SESSION["Main"]["Show"] = MAIN_MODE_ALL;}//Wenn alles geklappt hat, normale Ansicht aktualisieren
                  }
         }
         
  
                  
    /*Hochgeladene Datei prozessieren*/
    private function process_file()
        {
            //Als erstes Versuchen, ob die Datei mit momentan geladenem Save-Modul zu ffnen ist
            if($_SESSION["Module"]["Save"]["Active"]->read_file($_FILES["Cl_Upload_Default_File"]["tmp_name"]) === TRUE)//--> versuchen, ob die geladene Save-Klasse den File ffnen kann
                {
                    $_SESSION["Cl_Upload_Default"]["Type"]["Value"] = 4;
                    $_SESSION["Cl_Upload_Default"]["Type"]["Name"] = self::TEXT_MAKERGAUL;
                    $_SESSION["Cl_Upload_Default"]["Cycles"] = self::TEXT_ALL; //In diesem Fall funktioniert dass Zyklenabschneiden nicht, daher wird der Wert auf "Alle" gesetzt
                    return(TRUE);    //Wenn alles funktioniert, Funktion hier beenden
                } 
            /*CSV-Datei? Welcher Art? (Testen)*/
            elseif(strcasecmp(substr($_FILES["Cl_Upload_Default_File"]["name"],strlen($_FILES["Cl_Upload_Default_File"]["name"])-4,4),".csv") == 0) 
                {
                    //Versuchen, CSV-File zu laden--> erst mit normalen Komma versuchen
                    $this->csv_file = $this->read_csv(","); 
                    //Anhand der ersten Zeile Prfen, ob und wenn ja, welche 7300.csv-Datei vorliegt                 
                    if($this->csv_file !== FALSE && count($this->csv_file[0]) > 3 && $this->csv_file[0][0] === "Well" && $this->csv_file[0][1] === "Detector")
                        { 
                            $_SESSION["Cl_Upload_Default"]["Type"]["Value"] = 1;
                            $_SESSION["Cl_Upload_Default"]["Type"]["Name"] = self::TEXT_7300_DELTA_RN;
                            if($this->upload_delta_rn() === TRUE){return(TRUE);}    //Wenn alles funktioniert, Funktion hier beenden
                            else//Ansonsten mit Fehler beenden
                                {
                                    $this->show_error(self::TEXT_ERROR_6);
                                    return(FALSE);
                                }    
                        }
                    elseif($this->csv_file !== FALSE && count($this->csv_file[0]) > 2 && $this->csv_file[0][0] === "Well" && $this->csv_file[0][1] === "Dye Name")
                        {
                            $_SESSION["Cl_Upload_Default"]["Type"]["Value"] = 2;
                            $_SESSION["Cl_Upload_Default"]["Type"]["Name"] = self::TEXT_7300_COMPONENT; 
                            if($this->upload_components() === TRUE){return(TRUE);}    //Wenn alles funktioniert, Funktion hier beenden
                            else//Ansonsten mit Fehler beenden
                                {
                                    $this->show_error(self::TEXT_ERROR_7);
                                    return(FALSE);
                                }    
                        }
                    else//Versuchen, CSV-File zu laden--> jetzt mit Semikolon versuchen
                                {  
                                    $this->csv_file = $this->read_csv(";");     
                                    if($this->csv_file !== FALSE && count($this->csv_file[0]) > 3 && stristr($this->csv_file[0][0],"Well") !== FALSE && stristr($this->csv_file[0][1],"Name") !== FALSE && stristr($this->csv_file[0][2],"Detector") !== FALSE && stristr($this->csv_file[0][3],"Cycle") !== FALSE)
                                        {
                                            $_SESSION["Cl_Upload_Default"]["Type"]["Value"] = 5;
                                            $_SESSION["Cl_Upload_Default"]["Type"]["Name"] = self::TEXT_OWN; 
                                            if($this->upload_own_csv() === TRUE){return(TRUE);}    //Wenn alles funktioniert, Funktion hier beenden
                                            else//Ansonsten mit Fehler beenden
                                                {
                                                    $this->show_error(self::TEXT_ERROR_8);
                                                    return(FALSE);
                                                }    
                                        }
                                    else//Ansonsten mit Fehler beenden
                                                {
                                                    $this->show_error(self::TEXT_ERROR_8);
                                                    return(FALSE);
                                                }   
                                }    
                }
            //TXT-Datei?
            elseif(strcasecmp(substr($_FILES["Cl_Upload_Default_File"]["name"],strlen($_FILES["Cl_Upload_Default_File"]["name"])-4,4),".txt") == 0) 
                {
                    //Versuchen, CSV-File zu laden
                    $this->txt_file = $this->read_txt();  
                    //Anhand der ersten Zeile Prfen, ob 7300.txt-Datei vorliegt                 
                    if($this->txt_file !== FALSE)
                        {
                            //Existiert noch keine Platte? nix tun
                            if(!isset($_SESSION["Plate_Data"]) || $_SESSION["Plate_Data"] === NULL)
                                {
                                    $this->show_error(self::TEXT_ERROR_9); 
                                    return;
                                }
                            else{//Ansonsten Daten einlesen
                                    $_SESSION["Cl_Upload_Default"]["Type"]["Value"] = 3;
                                    $_SESSION["Cl_Upload_Default"]["Type"]["Name"] = self::TEXT_7300_SETUP;
                                    if($this->upload_sample_setup() === TRUE){return(TRUE);}    //Wenn alles funktioniert, Funktion hier beenden
                                    else//Ansonsten mit Fehler beenden
                                        {
                                            $this->show_error(self::TEXT_ERROR_10);
                                            return(FALSE);
                                        }    
                                } 
                        }
                    else//Ansonsten mit Fehler beenden
                                {
                                    $this->show_error(self::TEXT_ERROR_11);
                                    return(FALSE);
                                }    
                }
            //Ansonsten allgemeinen Fehler ausgeben
            $this->show_error(self::TEXT_ERROR_12);   
            return;  
        } 
        
    //Fehleranzeige generieren
    private function show_error($text)
        {
            $_SESSION["Main"]["Error"] = $text;
            $_SESSION["Main"]["Show"] = MAIN_MODE_ERROR;
        }    
         
    //CSV-DATEIEN EINLESEN
    private function read_csv($seperator)
        {
            /*Hochgeladene Datei an Datenstream anbinden*/
            $file = @fopen($_FILES["Cl_Upload_Default_File"]["tmp_name"],"r");
            //bei Fehlschlag abbrechen
            if($file === FALSE){return(FALSE);}
            
            $line = array();      /*Array fr die Zeilen*/
            $back_csv_file = array();  /*Array fr die komplette Datei*/
            $m=0;                 /*Zhlvariable*/
            /*Bis zum Ende der Datei Zeilen auslese*/
            while (!feof($file)) 
                {
                    $line = fgetcsv($file,0,$seperator);
                    //Nur Wenn das Auslesen einer CSV-Zeile funktioniert, diese auch dem Dateiarray hinzufgen (ACHTUNG: Typvergleich !==, da sonst mit dem String "FALSE" verglichen wird!)
                    if(($line !== FALSE))
                        {
                            $back_csv_file[$m] = $line;
                            $m++;
                        }
                }
            /*Stream schlieen (hochgeladene Datei wird als temporre Datei automatisch von PHP gelscht)*/
            fclose($file);
            return($back_csv_file);
        } 
        
    //TXT-DATEIEN EINLESEN
    private function read_txt()
        {
            /*Hochgeladene Datei an Datenstream anbinden*/
            $file = @fopen($_FILES["Cl_Upload_Default_File"]["tmp_name"],"r");
            //bei Fehlschlag abbrechen
            if($file === FALSE){return(FALSE);}
            
            $line = array();      /*Array fr die Zeilen*/
            $back_csv_file = array();  /*Array fr die komplette Datei*/
            $m=0;                 /*Zhlvariable*/
            /*Bis zum Ende der Datei Zeilen auslese*/
            while (!feof($file)) 
                {
                    $line = htmlentities(fgets($file), ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");
                    $element = explode(chr(9),$line); //Jede Zeile anhand von Tabs in Elemente teilen
                    //Nur Wenn das Auslesen einer CSV-Zeile funktioniert, diese auch dem Dateiarray hinzufgen (ACHTUNG: Typvergleich !==, da sonst mit dem String "FALSE" verglichen wird!)
                    if(($line !== FALSE))
                        {
                            $back_txt_file[$m] = $element;
                            $m++;
                        }
                }
            /*Stream schlieen (hochgeladene Datei wird als temporre Datei automatisch von PHP gelscht)*/
            fclose($file);
            return($back_txt_file);
        } 
         
    //ABI 7300 Components-Verarbeitung
    private function upload_components()
        {   
            //Plattendaten zurcksetzen & Array neu aufbauen
            $_SESSION["Module"]["Plate"]["Active"]->reset_data();
            $_SESSION["Plate_Facts"]["Area"] = 0;   
            
            /*Totes Ende finden, das abgeschnitten wird (Variiert von Exportdatei zu Exportdatei...)*/
            for($a = count($this->csv_file)-1; $a>0; $a--)
                {   
                echo($this->csv_file[$a][0]);
                    if(count($this->csv_file[$a]) > 1 && ctype_digit($this->csv_file[$a][0]) === TRUE) 
                        {
                            /*Platteneigenschaften: Gre bestimmen*/
                            $_SESSION["Plate_Facts"]["Area"] = intval($this->csv_file[$a][0]);//Letzte Wellnummer laden   
                            break;
                        }
                }
            //Keine letzte Wellnummer gefunden? abbrechen
            if($_SESSION["Plate_Facts"]["Area"]==0) {return(FALSE);}
            //Wenn die Gre feststeht, neue Platte vorbereiten
            $_SESSION["Module"]["Plate"]["Active"]->prepare_plate();
            //Wie viele Zyklen sollen importiert werden?
            $zyklen = $_SESSION["Cl_Upload_Default"]["Cycles"];
            if($_SESSION["Cl_Upload_Default"]["Cycles"] == self::TEXT_ALL){$zyklen = NULL;} //Wenn alles importiert werden soll, $zyklen auf NULL setzen (Wird dann von array_slice ignorirt)
            
            /*Daten bertragen*/
            for($i=2; $i < count($this->csv_file); $i+=2)
                {
                    if(!isset($this->csv_file[$i][0]) || $this->csv_file[$i][0] == 0){continue;} //Leerstellen berspringen
                    //Well-Nr
                    $number = intval(htmlentities($this->csv_file[$i][0], ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                    //Je Datenzeile ein neues Well erstellen. Lcken werden bercksichtigt ($_SESSION["Plate_Data"][x] entspricht der in $Filedata[$i][0] bergebenen Wellnummer)
                    $zwischen = array_slice($this->csv_file[$i],2,$zyklen);
                    //Alle Werte verkleinern
                    for($a=0; $a < count($zwischen); $a++)
                        {
                            $zwischen[$a] = bc_div(htmlentities($zwischen[$a], ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"),self::INT_FACTOR_7300_COMPONENT); //Werte werden mit Faktor INT_FACTOR_7300_COMPONENT verkleinert, um fr die Grenzwerte der Formeln passend zu sein
                        }
                    $_SESSION["Plate_Data"][$number]["Measured_Data"] = $zwischen;
                }
            if($_SESSION["Cl_Upload_Default"]["Cycles"] != self::TEXT_ALL){$_SESSION["Cl_Upload_Default"]["Cycles"] = count($zwischen);} //Wenn nicht alles importiert werden sollte, eingestellte Zyklen an die wirklich eingelesenen Zyklen anpassen
            return(TRUE);
        } 
    //ABI 7300 Delta-RN-Verarbeitung
    private function upload_delta_rn()
        {   
            //Plattendaten zurcksetzen & Array neu aufbauen
            $_SESSION["Module"]["Plate"]["Active"]->reset_data();
            $_SESSION["Plate_Facts"]["Area"] = 0;   
            
            /*Totes Ende finden, das abgeschnitten wird (Variiert von Exportdatei zu Exportdatei...)*/
            for($a = count($this->csv_file)-1; $a>0; $a--)
                {   
                    if(count($this->csv_file[$a]) > 1 && ctype_digit($this->csv_file[$a][0]) === TRUE) 
                        {
                            /*Platteneigenschaften: Gre bestimmen*/
                            $_SESSION["Plate_Facts"]["Area"] = intval($this->csv_file[$a][0]);//Letzte Wellnummer laden   
                            break;
                        }
                }
            //Keine letzte Wellnummer gefunden? abbrechen
            if($_SESSION["Plate_Facts"]["Area"]==0) {return(FALSE);}
            //Wenn die Gre feststeht, neue Platte vorbereiten
            $_SESSION["Module"]["Plate"]["Active"]->prepare_plate();
            //Wie viele Zyklen sollen importiert werden?
            $zyklen = $_SESSION["Cl_Upload_Default"]["Cycles"];
            if($_SESSION["Cl_Upload_Default"]["Cycles"] == self::TEXT_ALL){$zyklen = NULL;} //Wenn alles importiert werden soll, $zyklen auf NULL setzen (Wird dann von array_slice ignorirt)
                
            /*Daten bertragen*/
            for($i=1; $i < count($this->csv_file); $i++)
                {
                    if(!isset($this->csv_file[$i][0]) || $this->csv_file[$i][0] == 0){continue;} //Leerstellen berspringen
                    //Well-Nr
                    $number = intval(htmlentities($this->csv_file[$i][0], ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                    //Je Datenzeile ein neues Well erstellen. Lcken werden bercksichtigt ($_SESSION["Plate_Data"][x] entspricht der in $Filedata[$i][0] bergebenen Wellnummer)
                    $zwischen = array_slice($this->csv_file[$i],3,$zyklen);
                    //Alle Werte absichern
                    $_SESSION["Plate_Data"][$number]["Name"]["Detector"] = htmlentities($this->csv_file[$i][1], ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");
                    for($a=0; $a < count($zwischen); $a++)
                        {
                            $zwischen[$a] = htmlentities($zwischen[$a], ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"); //Werte werden gesichert
                        }
                    $_SESSION["Plate_Data"][$number]["Measured_Data"] = $zwischen; //abgesicherte Daten speichern
                }
            if($_SESSION["Cl_Upload_Default"]["Cycles"] != self::TEXT_ALL){$_SESSION["Cl_Upload_Default"]["Cycles"] = count($zwischen);} //Wenn nicht alles importiert werden sollte, eingestellte Zyklen an die wirklich eingelesenen Zyklen anpassen
            return(TRUE);
        } 
        
    //ABI 7300 Sample Setup laden
    private function upload_sample_setup()
        {   
            /*Totes Ende finden, das abgeschnitten wird (Variiert von Exportdatei zu Exportdatei...)*/
            for($a = count($this->txt_file)-1; $a>0; $a--)
                {  
                //Well-Nr
                $number = intval(htmlentities($this->txt_file[$a][0], ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1")); 
                //Nur Wells laden, die gefllt sind, noch nicht im Header liegen und die Plattengre respektieren 
                    if(count($this->txt_file[$a])>1 && strcasecmp($this->txt_file[$a][0],"Well") !== 0 && $number <= $_SESSION["Plate_Facts"]["Area"] && isset($_SESSION["Plate_Data"][$number]["Name"]["Well"])) //Nur Wells laden, die gefllt sind, die Plattengre respektieren und noch nicht im Header liegen
                        {
                            /*Platteneigenschaften: Name und Detektor*/
                            if(isset($this->txt_file[$a][1])){$_SESSION["Plate_Data"][$number]["Name"]["Well"] = htmlentities($this->txt_file[$a][1], ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");}
                            if(isset($this->txt_file[$a][2])){$_SESSION["Plate_Data"][$number]["Name"]["Detector"] = htmlentities($this->txt_file[$a][2],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");}
                        }
                }
            return(TRUE);
        } 
        
    //Eigene-CSV-Datei laden
    private function upload_own_csv()
        {   
            //Plattendaten zurcksetzen & Array neu aufbauen
            $_SESSION["Module"]["Plate"]["Active"]->reset_data();  
            $_SESSION["Plate_Facts"]["Area"] = 0;   
            
            /*Totes Ende finden, das abgeschnitten wird (Variiert von Exportdatei zu Exportdatei...)*/
            for($a = count($this->csv_file)-1; $a>0; $a--) //-3, da die beiden Statuszeilen nicht bercksichtigt werden
                {   
                    if(count($this->csv_file[$a]) > 1 && ctype_digit($this->csv_file[$a][0]) === TRUE) 
                        {
                            /*Platteneigenschaften: Gre bestimmen*/
                            $_SESSION["Plate_Facts"]["Area"] = intval($this->csv_file[$a][0]);//Letzte Wellnummer laden   
                            break;
                        }
                }
            //Keine letzte Wellnummer gefunden? abbrechen
            if($_SESSION["Plate_Facts"]["Area"]==0) {return(FALSE);}
            //Wenn die Gre feststeht, neue Platte vorbereiten
            $_SESSION["Module"]["Plate"]["Active"]->prepare_plate();
            //Wie viele Zyklen sollen importiert werden?
            $zyklen = $_SESSION["Cl_Upload_Default"]["Cycles"];
            if($_SESSION["Cl_Upload_Default"]["Cycles"] == self::TEXT_ALL){$zyklen = NULL;} //Wenn alles importiert werden soll, $zyklen auf NULL setzen (Wird dann von array_slice ignorirt)   
             
            /*Daten bertragen*/
            for($i=1; $i <= $a; $i++)
                {
                    if(!isset($this->csv_file[$i][0]) || $this->csv_file[$i][0] == 0){continue;} //Leerstellen berspringen
                    //Well-Nr
                    $number = intval(htmlentities($this->csv_file[$i][0], ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1"));
                    //Je Datenzeile ein neues Well erstellen. Lcken werden bercksichtigt ($_SESSION["Plate_Data"][x] entspricht der in $Filedata[$i][0] bergebenen Wellnummer)
                    $zwischen = array_slice($this->csv_file[$i],3,$zyklen);
                    //Alle Werte absichern
                    if(strlen($this->csv_file[$i][1])>0) {$_SESSION["Plate_Data"][$number]["Name"]["Well"] = htmlentities($this->csv_file[$i][1], ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");}
                    if(strlen($this->csv_file[$i][2])>0) {$_SESSION["Plate_Data"][$number]["Name"]["Detector"] = htmlentities($this->csv_file[$i][2], ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1");}
                    for($z=0; $z < count($zwischen); $z++)//abgesicherte Daten speichern
                        {
                            $_SESSION["Plate_Data"][$number]["Measured_Data"][$z] = str_replace(",",".",htmlentities($zwischen[$z],ENT_QUOTES|ENT_SUBSTITUTE,"ISO8859-1")); //Werte werden gesichert
                        }
                }
            if($_SESSION["Cl_Upload_Default"]["Cycles"] != self::TEXT_ALL){$_SESSION["Cl_Upload_Default"]["Cycles"] = count($zwischen);} //Wenn nicht alles importiert werden sollte, eingestellte Zyklen an die wirklich eingelesenen Zyklen anpassen
            return(TRUE);
        } 
}
